c
c.....celatm.inc - common containing information about the complete
c                  set of ions in the primitive cell.
c
c     ncel ....... number of atoms in the crystallographic cell.
c     typcel ..... type of atom (refers to the non-equivalent atom
c                  from which it comes).
c     {x,y,z}cel . cell coordinates of the atoms.
c     xxcel(,) ... two-index matrix that is equivalenced to the single-
c                  index vectors xcel()..zcel().
c     qcel ....... charge of the atom.
c     indcel ..... pointer that indicates the rotation (proper or
c                  improper) that generates the current position from the 
c                  Wyckoff position of the representative atom
c     epsfrac ... max error allowed in the cell coordinates for several
c                 routines.
c     epsdis .... max error allowed in the distances for several
c                 routines.
c
      integer           ncel, typcel, indcel
      common /celatm1/  typcel(mcel), indcel(mcel), ncel
      real*8            xcel, ycel, zcel, xxcel, qcel
      common /celatm2/  xcel(mcel), ycel(mcel), zcel(mcel), qcel(mcel)
      dimension         xxcel(mcel,3)
      equivalence       (xxcel(1,1), xcel(1))
      equivalence       (xxcel(1,2), ycel(1))
      equivalence       (xxcel(1,3), zcel(1))
      real*8            epsfrac, epsdis
      common /celatm3/  epsfrac, epsdis
