c
c-----------------------------------------------------------------------
c
      real*8 function charge (x, y, z)
c
c.....charge - determines the charge of the ion at (x,y,z) in the
c     host crystal, if any.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'celatm.inc'
      include           'consts.inc'
c
c.....translate (x,y,z) to the primitive cell:
c
      if (abs(x-nint(x)) .le. epsfrac) then
         xx = 0d0
      else if (x .ge. zero) then
         xx = x - int(x)
      else
         xx = x - int(x) + 1
      endif
      if (abs(y-nint(y)) .le. epsfrac) then
         yy = 0d0
      else if (y .ge. zero) then
         yy = y - int(y)
      else
         yy = y - int(y) + 1
      endif
      if (abs(z-nint(z)) .le. epsfrac) then
         zz = 0d0
      else if (z .ge. zero) then
         zz = z - int(z)
      else
         zz = z - int(z) + 1
      endif
c
c.....search for (xx,yy,zz) in the cell atom list:
c
      do i = 1, ncel
         if (abs(xx-xcel(i)) .le. epsfrac .and.
     &       abs(yy-ycel(i)) .le. epsfrac .and.
     &       abs(zz-zcel(i)) .le. epsfrac       ) then
            charge = qcel(i)
            return
         endif
      enddo
      charge = zero
      return
      end
