c
c-----------------------------------------------------------------------
c
      subroutine cluster (lur, luw, nimpre)
c
c.....cluster - special shell for the full calculation of a cluster.
c
      include           'cluster.doc'
c
      include           'implicit.inc'
      include           'global.inc'
c
      integer           lur, luw, nimpre
c
      include           'celatm.inc'
      include           'cont.inc'
      include           'consts.inc'
      include           'converge.inc'
      include           'corr.inc'
      include           'environ.inc'
      include           'error.inc'
      include           'files.inc'
      include           'impurity.inc'
      include           'lint.inc'
      include           'modatm.inc'
      include           'neqatm.inc'
      include           'red.inc'
      include           'spgcom.inc'
      include           'strtools.inc'
      include           'types.inc'
      include           'vef.inc'
      include           'rotmat.inc'
c
      integer           typrun
      logical           conv, done, ok, setline, setdble, setint, div
      logical           setword
      character*(256)   line
      character*(3)     itoa
      character*(ilen)  uppcase, word, word2, spg
      real*8            xcenter, ycenter, zcenter
      real*8            eclus(mcycles)
      real*8            cemp(mnt), cenlsr(mnt), cenllr(mnt), censr(mnt),
     &                  ceesr(mnt), ceex(mnt), cepl(mnt)
c
c.....initialize variables :
c
      call prtimer (2, ipid, 'cluster', luw)
      nneq = 0
      infsystem = .false.
      if (nimpre.ge.-1) write (luw,600)
c
c.....read input orders:
c
      done = .false.
      do while (.not. done)
         if (.not. setline (lur, line, lp)) then
            call error ('cluster', 'premature end of data', warning)
            return
         endif
         ll = leng(line)
         if (.not. setword (word2, line, lp)) then
            call error ('cluster', 'premature end of line', warning)
            return
         endif
         word = uppcase (word2)
         lw = leng(word)
         ok = .false.
c
c........case sentences to interpret word:
c
         if (word(1:1) .eq. '#' .or. word(1:lw) .eq. 'REM') then
c
c...........skip comment lines:
c
            ok = .true.
c
         else if (word(1:lw) .eq. 'NEQ') then
            nneq = nneq + 1
            if (nneq .gt. mnt) call error ('cluster',
     &         'max num of atom types exceeded. Increase mnt.',
     &         faterr)
            ok = setdble (xneq(nneq), line, lp)
            ok = ok .and. setdble (yneq(nneq), line, lp)
            ok = ok .and. setdble (zneq(nneq), line, lp)
            ok = ok .and. setword (fion(nneq), line, lp)
            ok = ok .and. setword (fulm(nneq), line, lp)
            ok = ok .and. setword (fcoef(nneq), line, lp)
            if (typcorr .eq. typrCHF) then
               ok = ok .and. setword (fcint(nneq), line, lp)
            else if (typcorr .eq. typuCHF) then
               ok = ok .and. setword (fint(nneq), line, lp)
               ok = ok .and. setword (fcint(nneq), line, lp)
            else
               ok = ok .and. setword (fint(nneq), line, lp)
            endif
            ok = ok .and. setword (flint(nneq), line, lp)
            xocup(nneq) = one
c
         else if (word(1:lw) .eq. 'CELL') then
            ok = setdble (ared, line, lp)
            ok = ok .and. setdble (bred, line, lp)
            ok = ok .and. setdble (cred, line, lp)
            ok = ok .and. setdble (alf, line, lp)
            ok = ok .and. setdble (bet, line, lp)
            ok = ok .and. setdble (gam, line, lp)
            if (nimpre.ge.-1)
     &         write (luw,605) ared, bred, cred, alf, bet, gam
            calf = cos (alf * rad)
            salf = sin (alf * rad)
            cbet = cos (bet * rad)
            sbet = sin (bet * rad)
            cgam = cos (gam * rad)
            sgam = sin (gam * rad)
            g(1) = ared * ared
            g(2) = ared * bred * cgam
            g(3) = bred * bred
            g(4) = ared * cred * cbet
            g(5) = bred * cred * calf
            g(6) = cred * cred
            if (nimpre.ge.-1)
     &         write (luw,606) g(1), g(2), g(4), g(2), g(3), g(5),
     &                         g(4), g(5), g(6)
c
         else if (word(1:lw) .eq. 'SPG') then
            do while (line(lp:lp) .eq. blank)
               lp = lp + 1
            enddo
            spg = line(lp:)
            ls = leng(spg)
            if (nimpre.ge.0) then
               iun = luw
            else
               iun = -1
            endif
            call spgr (spg,iun,luw,ier)
            if (ier.ne.0) then
               write (luw,*) 'spgr: error',ier
               call error ('crystal',
     &              'space group handler error', faterr)
            endif
            if (nimpre.ge.-1) write (luw,610) spg(1:ls)
            ok = .true.
c
         else if (word(1:lw) .eq. 'CENTER') then
            ok = setdble (xcenter, line, lp)
            ok = ok .and. setdble (ycenter, line, lp) 
            ok = ok .and. setdble (zcenter, line, lp)
c
         else if (word(1:lw) .eq. 'TITLE') then
            do while (line(lp:lp) .eq. blank)
               lp = lp + 1
            enddo
            titrun = line(lp:ll)
            lt = leng (titrun)
            if (nimpre.ge.-1) write (luw,607) titrun(:lt)
            ok = .true.
c
         else if (word(1:lw) .eq. 'ENDCLUSTER') then
            done = .true.
            ok = .true.
c
         else
            ok = .false.
         endif
c
c........trap reading errors:
c
         if (.not. ok) then
            call error ('cluster', 'order not recognized'//
     &                  newline//line(1:ll), faterr)
         endif
      enddo
c
c.....BEGIN THE RUN:
c
c.....(A): Build the cluster:
c
      do ni = 1, nneq
         call readion (fion(ni), ni, nimpre, luw)
         call readulm (fulm(ni), ni, nimpre, luw)
         call readcoef (fcoef(ni), ni, nimpre, luw)
         call vefion (fion(ni), ni, rdint, luw, nimpre-1)
         qneq(ni) = qclas(ni)
      enddo
      call symmloc (xcenter, ycenter, zcenter)
      root = sqrt(one-calf*calf-cbet*cbet-cgam*cgam+two*calf*cbet*cgam)
      omega = ared*bred*cred*root ! cell volume
      if (nimpre.ge.-1) then
         write (luw,615) (namneq(ni), mult(ni), ni = 1, nneq)
         qtotclus = 0
         do ni = 1, nneq
            qtotclus = qtotclus + qneq(ni) * xocup(ni) * mult(ni)
         enddo
         write (luw,618) qtotclus
         if (nimpre.ge.0) then
            write (luw,625) nimtot
            do ni = 1, nimtot
               ni1 = typimp(ni)
               write (luw,626) ni, ximp(ni), yimp(ni), zimp(ni),
     &                         qneq(ni1), namneq(ni1), ni1
            enddo
         endif
      endif
c
c.....(B): Store the Wigner coefficients for real spherical harmonics
c
      iwig = 0
c     iwig ... number of Wigner coefficients for real spherical
c              harmonics
      do j = 2, neqv
        icel = 1
c     icel ... number of atoms in the cluster
        done = .false.
        do while (.not.done .and. icel.le.nimtot)
          if (abs(indcel(icel)).eq.j) done = .true.
c     indcel(mcel) ... Pointer that indicates the rotation (proper or
c                      improper) that generates the current position from 
c                      the atom in the cluster
c                      indcel < 0 -> improper rotations
c                      indcel > 0 -> proper rotations
          icel = icel + 1
        enddo
        if (done) then
          iwig = iwig + 1
          indmat(j) = iwig
c     indmat(23) ... pointer that indicates the Wigner coefficients for
c                    real spherical harmonics
          call rotmat (iwig,j)
        endif
      enddo
c
c.....(C): Build environment desciption for each non-equivalent cluster
c     cluster ion:
c
*     Environment building moved to the intred routine
c
c.....(D): perform PI cycles until convergence or MAXPICYCLES:
c
      ncycle = 0
      conv = .false.
      div  = .false.
      done = (ncycle .ge. MAXPICYCLES)
      typrun = wrint
      nprtloc = nimpre - 1
      do while (.not. done)
         ncycle = ncycle + 1
         eclus(ncycle) = zero
         do ni = 1, nneq
            tition(ni) = namneq(ni)(1:leng(namneq(ni)))//':'//
     &                titrun(1:leng(titrun))//'. Cycle '//
     &                itoa(ncycle)
            if (typcorr .eq. typrCHF) then
               call istupq (fcint(ni),ni,typrCHF,typrun,luw,nprtloc)
            else
               call istupq (fint(ni),ni,typHF,typrun,luw,nprtloc)
            endif
            call intred (flint(ni), ni, typrun, luw, nprtloc)
            call scfat (ni, luw, nprtloc)
            if (typcorr .eq. typuCHF) then
               call uchf (ni, typrun, luw, nprtloc)
            endif
            call vefion (fion(ni), ni, nwint, luw, nprtloc)
            cemp(ni)      = emp
            cenlsr(ni)    = enlsr
            cenllr(ni)    = enllr
            censr(ni)     = ensr
            ceesr(ni)     = eesr
            ceex(ni)      = eex
            cepl(ni)      = epl
            eclus(ncycle) = eclus(ncycle) + eadd(ni) * mult(ni)
         enddo
         if (nimpre.ge.0)
     &      write (luw,700) ncycle, eclus(ncycle), (eadd(ni), ni=1,nneq)
         if (ncycle .gt. 1) then
            enerdif = abs (eclus(ncycle) - eclus(ncycle-1))
            if (enerdif .le. PICONV) then
               conv = .true.
               nprtloc = nimpre
            else if (enerdif .ge. PIDIV) then
               div = .true.
               nprtloc = nimpre
            endif
         else
            typrun = rdint
         endif
         if (conv .or. div .or. ncycle .gt. MAXPICYCLES) then
            done = .true.
         endif
      enddo
      if (div) then
         write (luw,711)
         call error ('cluster', 'Divergence condition for Eclus',
     &               faterr)
      else if (.not.conv) then
         write (luw,710)
         call error ('cluster', 'Convergence has not been reached',
     &               faterr)
      endif
      if (nimpre.ge.-2) then
         do ni = 1, nneq
            call writecoef (fcoef(ni), ni)
            call vefion (fion(ni), ni, wrint, luw, nprtloc)
         enddo
      endif
c
c.....(D2): Add correlation energy (Density functionals)
c
c      if (typcorr.eq.typWig .or. typcorr.eq.typGom .or.
c     &    typcorr.eq.typLYP .or. typcorr.eq.typBR) then
c         eclus(ncycle) = zero
c         do ni = 1, nneq
c            call correl (ni, luw, nimpre)
c            eclus(ncycle) = eclus(ncycle) + eadd(ni) * mult(ni)
c         enddo
c      endif
c
c.....(D3): If requested, symmetrize the interactions
c
      if (symmetrize) then
         call symmint (luw, nimpre, eclus(ncycle), ceex, cepl)
      endif
c
c.....(E): Short resume of results:
c
      if (nimpre.eq.-1)
     &   write (luw,700) ncycle, eclus(ncycle), (eadd(ni), ni=1,nneq)
      if (nimpre.ge.-1) then
         write (luw,671) ared, bred, cred, alf, bet, gam,
     &                   titrun(1:leng(titrun))
         if (typcorr .eq. typHF) then
            write (luw,673) 'HF (none)'
         else if (typcorr .eq. typuCHF) then
            write (luw,673) 'uCHF'
         else if (typcorr .eq. typrCHF) then
            write (luw,673) 'rCHF'
c         else if (typcorr .eq. typWig) then
c            write (luw,673) 'Wigner'
c         else if (typcorr .eq. typGom) then
c            write (luw,673) 'Gombas'
c         else if (typcorr .eq. typLYP) then
c            write (luw,673) 'Lee-Yang-Parr'
c         else if (typcorr .eq. typBR) then
c            write (luw,673) 'Brual-Rothstein'
         endif
         write (luw,677) ncycle
         write (luw,678)
         do ni = 1, nneq
            write (luw,680) namneq(ni), eadd(ni), eeff(ni), eint(ni),
     &          ekin(ni), ecorr(ni), cemp(ni)+cenllr(ni),
     &          censr(ni)+ceesr(ni)+cenlsr(ni), ceex(ni), cepl(ni)
         enddo
         write (luw,900)
         do ni = 1, nneq
            cenr = cenlsr(ni) + cenllr(ni)
            write (luw,910) namneq(ni), cemp(ni)+cenllr(ni)+censr(ni)
     &          +ceesr(ni)+cenlsr(ni),  cemp(ni)+censr(ni), cenr,
     &          cemp(ni), cenllr(ni), cenlsr(ni), censr(ni), ceesr(ni)
         enddo
         write (luw,690) eclus(ncycle)
c
c.....print resume of the HF subproduct when typuCHF is being run:
c
         if (typcorr .ne. typrCHF .and. typcorr.ne.typHF) then
            write (luw,673) 'HF (none)'
            write (luw,678)
            do ni = 1, nneq
               write (luw,680) namneq(ni), eadd(ni)-ecorr(ni),
     &             eeff(ni)-ecorr(ni), eint(ni), ekin(ni), ecorr(ni),
     &             cemp(ni)+cenllr(ni), censr(ni)+ceesr(ni)+cenlsr(ni),
     &             ceex(ni), cepl(ni)
            enddo
            eclusHF = zero
            do ni = 1, nneq
               eclusHF = eclusHF + (eadd(ni) - ecorr(ni)) * mult(ni)
            enddo
            write (luw,690) eclusHF
         endif
         write (luw,800)
         call prtimer (4, ipid, 'cluster', luw)
c
c.....On a nimpre<-1, print only the energy
c
      else
         write (luw,790) eclus(ncycle)
         call prtimer (4, ipid, 'cluster', -1)
      endif
c
c.....(F): end-of-cluster-run. Return to the general shell.
c
      return
c
 600  format ('1'/
     & 1x, '******************************************************'/
     & 1x, '**                - GPI: CLUSTER -                  **'/
     & 1x, '** Shell designed for easy runs on finite clusters  **'/
     & 1x, '**       (c) C.J.F. Solano.  October 29, 1991       **'/
     & 1x, '******************************************************'// )
 605  format (1x, '*** CELL PARAMETERS  : ', 6(1x,f14.6))
 606  format (1x, '*** METRIC TENSOR    : ', 3(1x,f14.6) /
     &                                2(24x, 3(1x,f14.6) /) )
 607  format (1x, '*** CLUSTER TITLE    : ', a)
 610  format (1x, '*** SPACE GROUP      : ', a)
 615  format (1x, '*** CLUSTER          : ', (1x,4(a6,'(',i3,')',2x)))
 618  format (1x, '*** NET CHARGE       : ', f9.6)
 625  format (/1x, 'Total number of atoms in the cluster : ', i5/
     & 1x, '---i------x-----------y-----------z-----------q----name',
     &     '---type')
 626  format (1x, i4, 3(1x,f11.8), 1x, f9.5, 1x, a6, 1x, i4)
 640  format (/1x, 'Ion # ', i3, 1x, a6, '  Madelung potential: ',
     & 1pe17.8)
 671  format (/
     & 1x, '******************************************************'/
     & 1x, '***           CLUSTER RESUME OF RESULTS            ***'/
     & 1x, '******************************************************'//
     & 1x, '*** CELL SIZE : ', 6(1x,f14.6)/
     & 1x, '*** RUN TITLE : ', a)
 673  format (/1x,'*** CORRELATION  : ', a)
 677  format (1x,'*** PI CYCLES : ', i4)
 678  format (
     & 1x, 'Ion---------Eadd----------Eeff--------Eint-',
     &     '-------Ekin-------Ecorr-------Emp---',
     &     '----Ecsr--------Eex-------Epl--' )
 680  format (1x, a6, 2(1x,f13.6), 1x, f9.6, 1x, f12.6, 2(1x,f10.6),
     &        3(1x,f9.6))
 900  format (/1x, '*** Breakdown of Coulomb energy: ',/,
     & 1x, 'Ion----------Ec-------------Ecl----------Enuclat------',
     &     '--Eemp-----------Enmp--------Enlsr----------Ensr-------',
     &     '--Eesr----')
 910  format (1x,a6, 8(1x,f13.6))
 690  format (/
     & 1x, '*** Total effective energy of the cluster   : ', 1pe22.14)
 695  format (
     & 1x, '*** Polarization energy of the cluster      : ', 1pe22.14/
     & 1x, '*** Rigid (eff-pol) energy of the cluster   : ', 1pe22.14)
 700  format (1x, '*** Pi cycle # ',i3,'  Eclus: ', f25.15, '  Eadd: ',
     & 3f15.6, / (1x,10f15.6) )
 710  format (/
     & 1x, '***'/
     & 1x, '*** CAUTION: convergence has not been reached at cluster.'/
     & 1x, '***'/ )
 711  format (/
     & 1x, '***'/
     & 1x, '*** CAUTION: PI cycles stopped due to divergence in Eclus'/
     & 1x, '***'/ )
 790  format (1x,e24.16)
 800  format (/1x, '*** END OF CLUSTER RUN **************************')
      end
