c
c-----------------------------------------------------------------------
c
      subroutine crystal (lur, luw, nimpre)
c
c.....crystal - shell specialized in PI calculations of pure crystals.
c
      include           'crystal.doc'
c
      include           'implicit.inc'
      include           'global.inc'
c
      include           'celatm.inc'
      include           'cont.inc'
      include           'consts.inc'
      include           'converge.inc'
      include           'corr.inc'
      include           'environ.inc'
      include           'error.inc'
      include           'files.inc'
      include           'lint.inc'
      include           'neqatm.inc'
      include           'red.inc'
      include           'spgcom.inc'
      include           'strtools.inc'
      include           'types.inc'
      include           'vef.inc'
      include           'ewald.inc'
      include           'rsh.inc'
      include           'rotmat.inc'
c
      integer           lur, luw, nimpre
c
      logical           setword, conv, done, ok, setline, setdble
      logical           setint
      character*(ilen)  uppcase, word, word2, spg
      character*(256)   line
      character*(3)     itoa
      real*8            ecrys(mcycles)
      real*8            cemp(mnt), cenlsr(mnt), cenllr(mnt), censr(mnt),
     &                  ceesr(mnt), ceex(mnt), cepl(mnt)
c
c.....initialize variables :
c
      call prtimer (2, ipid, 'crystal', luw)
      nneq = 0
      infsystem = .true.
      enerdif = zero
      if (nimpre.ge.-1) write (luw,600)
c
c.....read input orders:
c
      fractional = .false.
      done = .false.
      do while (.not. done)
         if (.not. setline (lur, line, lp)) then
            call error ('crystal', 'premature end of data', warning)
            return
         endif
         ll = leng(line)
         if (.not. setword (word2, line, lp)) then
            call error ('crystal', 'premature end of line', warning)
            return
         endif
         word = uppcase (word2)
         lw = leng(word)
         ok = .false.
c
c........case sentences to interpret word:
c
         if (word(1:1) .eq. '#' .or. word(1:lw) .eq. 'REM') then
c
c...........skip comment lines:
c
            ok = .true.
c
         else if (word(1:lw) .eq. 'NEQ') then
            nneq = nneq + 1
            ok = setdble (xneq(nneq), line, lp)
            ok = ok .and. setdble (yneq(nneq), line, lp)
            ok = ok .and. setdble (zneq(nneq), line, lp)
            ok = ok .and. setword (fion(nneq), line, lp)
            ok = ok .and. setword (fulm(nneq), line, lp)
            ok = ok .and. setword (fcoef(nneq), line, lp)
            if (typcorr .eq. typrCHF) then
               ok = ok .and. setword (fcint(nneq), line, lp)
            else if (typcorr .eq. typuCHF) then
               ok = ok .and. setword (fint(nneq), line, lp)
               ok = ok .and. setword (fcint(nneq), line, lp)
            else
               ok = ok .and. setword (fint(nneq), line, lp)
            endif
            ok = ok .and. setword (flint(nneq), line, lp)
            xocup(nneq) = one
c
         else if (word(1:lw) .eq. 'FNEQ') then
            fractional = .true.
            nneq = nneq + 1
            ok = setdble (xneq(nneq), line, lp)
            ok = ok .and. setdble (yneq(nneq), line, lp)
            ok = ok .and. setdble (zneq(nneq), line, lp)
            ok = ok .and. setdble (xocup(nneq), line, lp)
            ok = ok .and. setword (fion(nneq), line, lp)
            ok = ok .and. setword (fulm(nneq), line, lp)
            ok = ok .and. setword (fcoef(nneq), line, lp)
            if (typcorr .eq. typrCHF) then
               ok = ok .and. setword (fcint(nneq), line, lp)
            else if (typcorr .eq. typuCHF) then
               ok = ok .and. setword (fint(nneq), line, lp)
               ok = ok .and. setword (fcint(nneq), line, lp)
            else
               ok = ok .and. setword (fint(nneq), line, lp)
            endif
            ok = ok .and. setword (flint(nneq), line, lp)
c
         else if (word(1:lw) .eq. 'SPG') then
            do while (line(lp:lp) .eq. blank)
               lp = lp + 1
            enddo
            spg = line(lp:)
            ls = leng(spg)
            if (nimpre.ge.0) then
               iun = luw
            else
               iun = -1
            endif
            call spgr (spg,iun,luw,ier)
            if (ier.ne.0) then
               write (luw,*) 'spgr: error',ier
               call error ('crystal',
     &              'space group handler error', faterr)
            endif
            if (nimpre.ge.-1) write (luw,610) spg(1:ls)
            ok = .true.
c
         else if (word(1:lw) .eq. 'CELL') then
            ok = setdble (ared, line, lp)
            ok = ok .and. setdble (bred, line, lp)
            ok = ok .and. setdble (cred, line, lp)
            ok = ok .and. setdble (alf, line, lp)
            ok = ok .and. setdble (bet, line, lp)
            ok = ok .and. setdble (gam, line, lp)
            if (nimpre.ge.-1)
     &         write (luw,605) ared, bred, cred, alf, bet, gam
            calf = cos (alf * rad)
            salf = sin (alf * rad)
            cbet = cos (bet * rad)
            sbet = sin (bet * rad)
            cgam = cos (gam * rad)
            sgam = sin (gam * rad)
            g(1) = ared * ared
            g(2) = ared * bred * cgam
            g(3) = bred * bred
            g(4) = ared * cred * cbet
            g(5) = bred * cred * calf
            g(6) = cred * cred
            if (nimpre.ge.-1)
     &         write (luw,606) g(1), g(2), g(4), g(2), g(3), g(5),
     &                         g(4), g(5), g(6)
c
         else if (word(1:lw) .eq. 'TITLE') then
            do while (line(lp:lp) .eq. blank)
               lp = lp + 1
            enddo
            titrun = line(lp:ll)
            lt = leng (titrun)
            if (nimpre.ge.-1) write (luw,607) titrun(:lt)
            ok = .true.
c
         else if (word(1:lw) .eq. 'ENDCRYSTAL') then
            done = .true.
            ok = .true.
c
         else
            ok = .false.
         endif
c
c........trap lecture errors:
c
         if (.not. ok) then
            call error ('crystal', 'order not recognized'//
     &                  newline//line(1:ll), faterr)
         endif
      enddo
c
c.....BEGIN THE RUN:
c
c.....(A): Build the unit cell:
c
      do ni = 1, nneq
         call readion (fion(ni), ni, nimpre, luw)
         call readulm (fulm(ni), ni, nimpre, luw)
         call readcoef (fcoef(ni), ni, nimpre, luw)
         call vefion (fion(ni), ni, rdint, luw, nimpre-1)
         qneq(ni) = qclas(ni)
      enddo
      call create (1, nneq)
      zmult = mcdvec (mult, 1, nneq)
      qtotcel = 0
      do ni = 1, nneq
         qtotcel = qtotcel + qneq(ni) * xocup(ni) * (mult(ni)/zmult)
      enddo
      if (abs(qtotcel) .gt. 1d-5) then
         call error ('crystal','The Ewald routine is not warrantied '//
     &               'to give physical results when the unit cell has'//
     &               ' a net charge.',warning)
      endif
      root = sqrt(one-calf*calf-cbet*cbet-cgam*cgam+two*calf*cbet*cgam)
      omega = ared*bred*cred*root ! cell volume
      if (nimpre.ge.-1) then
         write (luw,615) (namneq(ni), (mult(ni)/zmult)*xocup(ni),
     &                   ni = 1, nneq)
         write (luw,616) zmult
         write (luw,617) qtotcel
         write (luw,618) omega
         write (luw,619) omega/zmult
         write (luw,620) nneq
         do ni = 1, nneq
            write (luw,625) ni, xneq(ni), yneq(ni), zneq(ni), xocup(ni),
     &                      qneq(ni), namneq(ni), mult(ni)
         enddo
         if (nimpre.ge.0) then
            write (luw,630) ncel
            do i = 1, ncel
               write (luw,635) xcel(i), ycel(i), zcel(i), qcel(i),
     &                         typcel(i), xocup(typcel(i))
            enddo
         endif
      endif
c
c.....(B): Store the Wigner coefficients for real spherical harmonics
c
      iwig = 0
c     iwig ... number of Wigner coefficients for real spherical
c              harmonics
      do j = 2, neqv
        icel = 1
c     icel ... number of atoms in the unit cell 
        done = .false.
        do while (.not.done .and. icel.le.ncel)
          if (abs(indcel(icel)).eq.j) done = .true.
c     indcel(mcel) ... Pointer that indicates the rotation (proper or
c                      improper) that generates the current position from 
c                      the Wyckoff position of the representative atom
c                      indcel < 0 -> improper rotations
c                      indcel > 0 -> proper rotations
          icel = icel + 1
        enddo
        if (done) then
          iwig = iwig + 1
          indmat(j) = iwig
c     indmat(23) ... pointer that indicates the Wigner coefficients for
c                    real spherical harmonics
          call rotmat (iwig,j)
        endif
      enddo
c
c.....(C): Obtain Madelung potential at the non-equivalent ion sites:
c
      call preewald ()
c
c.....(D): Build environment desciption for each non-equivalent ion:
c
*     Environment building moved to intred routine
c
c.....(E): run first pi iteration
c
      ncycle = 1
      ecrys(ncycle) = zero
      do ni = 1, nneq
         tition(ni) = namneq(ni)(1:leng(namneq(ni)))//':'//
     &                titrun(1:leng(titrun))//'. Cycle   1'
         if (typcorr .eq. typrCHF) then
            call istupq (fcint(ni), ni, typrCHF, wrint, luw, nimpre-1)
         else
            call istupq (fint(ni), ni, typHF, wrint, luw, nimpre-1)
         endif
         call intred (flint(ni), ni, wrint, luw, nimpre-1)
         call scfat (ni, luw, nimpre-1)
         if (typcorr .eq. typuCHF) then
            call uchf (ni, wrint, luw, nimpre-1)
         endif
         call vefion (fion(ni), ni, nwint, luw, nimpre-1)
         ecrys(ncycle) = ecrys(ncycle) + eadd(ni) * (mult(ni)/zmult) *
     &                    xocup(ni)
      enddo
      if (nimpre.ge.0)
     &   write(luw,700) ncycle, ecrys(ncycle), (eadd(ni), ni = 1, nneq)
c
c.....(F): perform pi cycles up to convergence or MAXPICYCLES:
c
      done = (1 .ge. MAXPICYCLES)
      conv = .false.
      do while (.not. done)
         ncycle = ncycle + 1
         ecrys(ncycle) = zero
         do ni = 1, nneq
            tition(ni) = namneq(ni)(1:leng(namneq(ni)))//':'//
     &                titrun(1:leng(titrun))//'. Cycle '//itoa(ncycle)
            if (typcorr .eq. typrCHF) then
               call istupq (fcint(ni),ni,typrCHF,rdint,luw,nimpre-1)
            else
               call istupq (fint(ni),ni,typHF,rdint,luw,nimpre-1)
            endif
            call intred (flint(ni), ni, rdint, luw, nimpre-1)
            call scfat (ni, luw, nimpre-1)
            if (typcorr .eq. typuCHF) then
               call uchf (ni, rdint, luw, nimpre-1)
            endif
            call vefion (fion(ni), ni, nwint, luw, nimpre-1)
            ecrys(ncycle) = ecrys(ncycle) + eadd(ni) *
     &                       (mult(ni)/zmult) * xocup(ni)
         enddo
         if (nimpre.ge.0)
     &      write(luw,700) ncycle, ecrys(ncycle), (eadd(ni), ni=1,nneq)
         enerdif = abs (ecrys(ncycle) - ecrys(ncycle-1))
         conv = enerdif .le. PICONV
         done = conv .or. ncycle.ge.MAXPICYCLES .or. enerdif.ge.PIDIV
      enddo
      if (enerdif .ge. PIDIV) then
         write (luw,711)
         call error ('crystal', 'Divergence condition for Ecryst',
     &               faterr)
      else if (.not.conv) then
         write (luw,710)
         call error ('crystal', 'Convergence has not been reached',
     &               faterr)
      endif
c
c.....(G): do a last PI cycle printing out at the normal level:
c
      ncycle = ncycle + 1
      ecrys(ncycle) = zero
      do ni = 1, nneq
         tition(ni) = namneq(ni)(1:leng(namneq(ni)))//':'//
     &             titrun(1:leng(titrun))//'. Cycle '//itoa(ncycle)
         if (typcorr .eq. typrCHF) then
            call istupq (fcint(ni),ni,typrCHF,rdint,luw,nimpre-1)
         else
            call istupq (fint(ni),ni,typHF,rdint,luw,nimpre-1)
         endif
         call intred (flint(ni), ni, rdint, luw, nimpre)
         call scfat (ni, luw, nimpre)
         if (typcorr .eq. typuCHF) then
            call uchf (ni, rdint, luw, nimpre)
         endif
         call vefion (fion(ni), ni, nwint, luw, nimpre)
         if (nimpre.ge.-2) then
           call writecoef (fcoef(ni), ni)
           call vefion (fion(ni), ni, wrint, luw, nimpre-2)
         endif
         ecrys(ncycle) = ecrys(ncycle) + eadd(ni) * (mult(ni)/zmult) *
     &                   xocup(ni)
         cemp(ni)      = emp 
         cenlsr(ni)    = enlsr
         cenllr(ni)    = enllr
         censr(ni)     = ensr
         ceesr(ni)     = eesr
         ceex(ni)      = eex
         cepl(ni)      = epl
      enddo
      if (nimpre.ge.-1) then
         write (luw,700) ncycle, ecrys(ncycle), (eadd(ni), ni=1,nneq)
      endif
c
c.....(G2): Add correlation energy (Density functionals)
c
c      if (typcorr.eq.typWig .or. typcorr.eq.typGom .or.
c     &    typcorr.eq.typLYP .or. typcorr.eq.typBR) then
c         ecrys(ncycle) = zero
c         do ni = 1, nneq
c            call correl (ni, luw, nimpre)
c            ecrys(ncycle) = ecrys(ncycle) + eadd(ni) *
c     &                    (mult(ni)/zmult) * xocup(ni)
c         enddo
c      endif
c
c.....(G3): If requested, symmetrize the interactions
c
      if (symmetrize) then
         call symmint (luw, nimpre, ecrys(ncycle), ceex, cepl)
      endif
c
c.....(G): Short resume of results:
c
      if (nimpre.ge.-1) then
         write (luw,671) ared, bred, cred, alf, bet, gam,
     &                   titrun(1:leng(titrun))
         if (typcorr .eq. typHF) then
            write (luw,673) 'HF (none)'
         else if (typcorr .eq. typuCHF) then
            write (luw,673) 'uCHF'
         else if (typcorr .eq. typrCHF) then
            write (luw,673) 'rCHF'
c         else if (typcorr .eq. typWig) then
c            write (luw,673) 'Wigner'
c         else if (typcorr .eq. typGom) then
c            write (luw,673) 'Gombas'
c         else if (typcorr .eq. typLYP) then
c            write (luw,673) 'Lee-Yang-Parr'
c         else if (typcorr .eq. typBR) then
c            write (luw,673) 'Brual-Rothstein'
         endif
         write (luw,677) ncycle
         write (luw,678)
         do ni = 1, nneq
            write (luw,680) namneq(ni), eadd(ni), eeff(ni), eint(ni),
     &          ekin(ni), ecorr(ni), cemp(ni)+cenllr(ni), 
     &          censr(ni)+ceesr(ni)+cenlsr(ni), ceex(ni), cepl(ni)
         enddo
         write (luw,900)
         do ni = 1, nneq
            cenr = cenlsr(ni) + cenllr(ni)
            write (luw,910) namneq(ni), cemp(ni)+cenllr(ni)+censr(ni)
     &          +ceesr(ni)+cenlsr(ni),  cemp(ni)+censr(ni), cenr,
     &          cemp(ni), cenllr(ni), cenlsr(ni), censr(ni), ceesr(ni)
         enddo
         ekintot = zero
         epottot = zero
         do ni = 1, nneq
            ekintot = ekintot + ekin(ni) * (mult(ni)/zmult) * xocup(ni)
            cenet   = eeff(ni) - eint(ni)
            cepot   = cenet - ekin(ni)
            epottot = epottot + cepot * (mult(ni)/zmult) * xocup(ni)
         enddo
         vircryst = epottot / ekintot
         write (luw,685) ecrys(ncycle), vircryst
c
c.....print resume of the HF subproduct when typuCHF is being run:
c
         if (typcorr .ne. typrCHF .and. typcorr.ne.typHF) then
            write (luw,673) 'HF (none)'
            write (luw,678)
            do ni = 1, nneq
               write (luw,680) namneq(ni), eadd(ni)-ecorr(ni),
     &             eeff(ni)-ecorr(ni), eint(ni), ekin(ni), ecorr(ni),
     &             cemp(ni)+cenllr(ni), censr(ni)+ceesr(ni)+cenlsr(ni),
     &             ceex(ni), cepl(ni)
            enddo
            ekintot = zero
            epottot = zero
            ecrysHF = zero
            do ni = 1, nneq
               ecrysHF = ecrysHF + (eadd(ni) - ecorr(ni)) *
     &                   (mult(ni)/zmult) * xocup(ni)
               ekintot = ekintot +
     &                   ekin(ni) * (mult(ni)/zmult) * xocup(ni)
               cenet   = eeff(ni) - ecorr(ni) - eint(ni)
               cepot   = cenet - ekin(ni)
               epottot = epottot + cepot * (mult(ni)/zmult) * xocup(ni)
            enddo
            vircryst = epottot / ekintot
            write (luw,685) ecrysHF, vircryst
         endif
c
c.....(H): end-of-crystal-run.
c
         write (luw,800)
         call prtimer (4, ipid, 'crystal', luw)
c
c.....On a nimpre<-1, print only the energy.
      else
         write (luw,790) ecrys(ncycle)
         call prtimer (4, ipid, 'crystal', -1)
      endif
      return
c
 600  format ('1'/
     & 1x, '******************************************************'/
     & 1x, '**                  - GPI: CRYSTAL -                **'/
     & 1x, '** Shell designed for easy runs on pure 3D crystals **'/
     & 1x, '**       (c) C.J.F Solano.  March 19, 1991          **'/
     & 1x, '******************************************************'// )
 605  format (1x, '*** CELL PARAMETERS  : ', 6(1x,f14.6))
 610  format (1x, '*** SPACE GROUP      : ', a)
 606  format (1x, '*** METRIC TENSOR    : ', 3(1x,f14.6) /
     &                                2(24x, 3(1x,f14.6) /) )
 607  format (1x, '*** CELL TITLE       : ', a)
 615  format (1x, '*** HOST CRYSTAL     : ', (1x,4(a6,'(',f9.6,')',2x)))
 616  format (1x, '*** FORMULAS/CELL (Z): ', i4)
 617  format (1x, '*** NET CHARGE/CELL  : ', f9.6)
 618  format (1x, '*** CELL VOLUME (au) : ', 1pe20.11)
 619  format (1x, '*** FORMULA VOLUME   : ', 1pe20.11)
 620  format (/
     & 1x, 'Non-equivalent atoms in the unit cell : ', i4/
     & 1x, '-i-----x----------y----------z--------ocup--',
     &     '---q--------name---mult')
 625  format (i3, 3(1x,f10.8), 1x, f8.6, 1x, f9.5, 1x, a6, 1x, i4)
 630  format (/1x, 'Total number of atoms in the unit cell : ', i5/ 1x,
     & '-----x----------y----------z----------q------type-------ocup')
 635  format (1x, 3(1x,f10.8), 1x, f9.5, 1x, i4, 1x, f10.6)
 671  format (/
     & 1x, '******************************************************'/
     & 1x, '***           CRYSTAL RESUME OF RESULTS            ***'/
     & 1x, '******************************************************'//
     & 1x, '*** CELL SIZE : ', 6(1x,f14.6)/
     & 1x, '*** RUN TITLE : ', a)
 673  format (/1x,'*** CORRELATION  : ', a)
 677  format (1x,'*** PI CYCLES : ', i4)
 678  format (
     & 1x, 'Ion---------Eadd----------Eeff--------Eint-',
     &     '-------Ekin-------Ecorr-------Emp---',
     &     '----Ecsr--------Eex-------Epl--' )
 680  format (1x, a6, 2(1x,f13.6), 1x, f9.6, 1x, f12.6, 2(1x,f10.6),
     &        3(1x,f9.6))
 900  format (/1x, '*** Breakdown of Coulomb energy: ',/,
     & 1x, 'Ion----------Ec-------------Ecl----------Enuclat------',
     &     '--Eemp-----------Enmp--------Enlsr----------Ensr-------',
     &     '--Eesr----')
 910  format (1x,a6, 8(1x,f13.6))
 685  format (/1x, '*** Crystal energy: ', f24.12, 4x,
     & 'Crystalline virial: ', f12.7)
 700  format (1x, '*** Pi cycle # ',i3,'  Ecrys: ', f21.12, '  Eadd: ',
     & 4f15.6, (/1x,10f15.6) )
 710  format (/
     & 1x, '***'/
     & 1x, '*** CAUTION: convergence has not been reached at crystal.'/
     & 1x, '***'/ )
 711  format (/
     & 1x, '***'/
     & 1x, '*** CAUTION: PI cycles stopped due to divergence in Ecryst'/
     & 1x, '***'/ )
 790  format (1x,e24.16)
 800  format (/1x, '*** END OF CRYSTAL RUN **************************')
      end
