c
c-----------------------------------------------------------------------
c
      subroutine densi (ni)
c
c.....densi - computes the total and open shell density matrices,
c     DT() and DOS() respectively.
c
c     The generic element of the density matrix is:
c
c                         *
c     Dil(pq) = Nil Cilp Cilq
c
c     where Nil is the electronic population of the il shell, and Cilp
c     is the coefficient of the p-th STO in the i-th orbital of the l
c     simetry. Then
c
c                 all orb.
c     DTl(pq) =    SUMA    Dil(pq)
c                   i
c
c                 open shell
c     DOSl(pq) =     SUMA      Dml(pq)
c                     m
c
      include           'implicit.inc'
      include           'global.inc'
      include           'cont.inc'
      include           'symmetry.inc'
      include           'scf.inc'
c
      k = 1
      nstep = 0
      do 10 i = 1, nirrep(ni)
         nbas1 = npgao(i, ni)
         nsh = ncsh(i,ni)+nosh(i,ni)
         do 15 j = 1, nbas1
            do 20 l = 1, j
               term1 = 0d0
               term2 = 0d0
               if (ncsh(i,ni).gt.0) then
                  do 25 m = 1, ncsh(i,ni)
                     m1 = m+nstep
                     term1 = term1+ngelec(m1,ni)*gc(j,m1,ni)*gc(l,m1,ni)
 25               continue
               endif
               if (nosh(i,ni).gt.0) then
                  m1 = nstep+nsh
                  term2 = term2+ngelec(m1,ni)*gc(j,m1,ni)*gc(l,m1,ni)
               endif
               if (j.ne.l) then
                  term1 = term1+term1
                  term2 = term2+term2
               endif
               dos(k) = term2
               dt(k) = term1+term2
               k = k+1
 20         continue
 15      continue
         nstep = nstep+nsh
 10   continue
      end
