c
c-----------------------------------------------------------------------
c
      subroutine extra (ni)
c
c.....extra - extrapolate coefficients of the 3 last diagonalizations.
c
c     The extrapolation formula is:
c
c     C = C(i) + (C(i) - C(i-1)) f
c
c     where
c
c     f = (C(i) - C(i-1)) / (2 C(i-1) - C(i) - C(i-2))
c
c     The extrapolation will be done only when f<2.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'symmetry.inc'
      include           'cont.inc'
      include           'intg.inc'
      include           'scf.inc'
c
      nstep1 = 0
      nstep2 = 0
      do 10 i = 1, nirrep(ni)
         nbas1 = npgao(i,ni)
         nsh = ncsh(i,ni)+nosh(i,ni)
         do 15 j = 1, nsh
            j1 = j+nstep1
            do 20 m = 1, nbas1
               ci = gc(m,j1,ni)
               ci1 = cm1scf(m,j1)
               ci2 = cm2scf(m,j1)
               if (abs(ci-ci1).gt.1d-9.and.abs(ci1-ci2).gt.1d-9) then
                  term = (ci-ci1)/(ci1+ci1-ci-ci2)
                  if (abs(term).lt.2d0) then
                     gc(m,j1,ni) = ci+term*(ci-ci1)
                  endif
               endif
 20         continue
c
c...........Normalize the extrapolated vector:
            suma = 0d0
            do 25 m = 1, nbas1
               do 30 k = 1, m
                  kp = nstep2+(m*(m-1))/2+k
                  term = gc(m,j1,ni)*ss(kp)*gc(k,j1,ni)
                  if (m.ne.k) term = 2d0*term
                  suma = suma+term
 30            continue
 25         continue
            xnorma = 1d0/sqrt(abs(suma))
            do 35 m = 1, nbas1
               gc(m,j1,ni) = xnorma*gc(m,j1,ni)
 35         continue
 15      continue
         nstep2 = nstep2+(nbas1*(nbas1+1))/2
         nstep1 = nstep1+nsh
 10   continue
      return
      end
