c
c.....global.inc - program parameters:
c     ilen ...... standard length for the character strings.
c     MNT ....... max number of ionic types.
c     MCEL ...... max number of atoms in the primitive cell.
c     MPURE ..... max number of non equivalent atoms in the pure crystal
c                 cell for impurity calculations.
c     MIMP ...... max number of impurity atoms (including symmetric-
c                 equivalent ones) in impurity calculations.
c     MRED ...... max number of ions in the environment.
c     MNBUFF .... size of the atom's buffer needed while building the
c                 environments.
c     MPOT ...... max number of different potentials in piip
c                 calculations.
c     MAOS ...... max number of AOs in each atom.
c     MSA ....... max number of symmetries in each atom.
c     MSTO ...... max number of primitives (STOs) in each atom.
c     MSTOSYM ... max number of primitives in each symmetry.
c     MDENS ..... max number of charge densities (over primitives) in
c                 the central ion (ion # 0).
c     MAXPQ ..... max number of elements in P() and Q():
c                 (MDENS*(MDENS+1))/2.
c     NAMAX ..... max principal quantum number, used in Silverstone
c                 routines.
c     MNATOM .... max atomic number, used in CHF correlation estimate.
c     MCYCLES ... max number of pi cycles.
c     MIRREP .... max number of irreps.
c     MSUB   .... max number of subspecies for each irrep.
c     LMAX  .... max number of lm = l*(l+1) + m.
c     MAIRREP ... max number of repetitions of irreps in the real
c                 spherical harmonics.
c     MPGAO ..... max number of functions adapted to the symmetry in a
c                 irrep.
c     MAXMP ..... max allowed multipole order.
c     MAXL ...... max accesible l number in Coulomb interactions.
c     LMMAX ..... max number of lm = l*(l+1) + m, where l = maxmp.
c     L2MMAX ..... max number of lm = l*(l+1) + m, where l = maxl.
c
      integer           ilen, mnt, mcel, mpure, mimp, mred, mnbuff, mpot
      integer           maos, msa, msto, mstosym, mdens, maxpq, namax
      integer           mnatom, mcycles
      integer           mirrep, msub, lmax
      integer           mairrep, mpgao
      integer           maxmp, maxl, lmmax
      parameter         (ilen    = 80   )
      parameter         (mnt     = 90   )
      parameter         (mcel    = 730  )
      parameter         (mpure   = 20   )
      parameter         (mimp    = 520  )
      parameter         (mred    = 2500 )
      parameter         (mnbuff  = 9999 )
      parameter         (mpot    = 100  )
      parameter         (maos    = 17   )
      parameter         (msa     = 4    )
      parameter         (msto    = 44   )
      parameter         (mstosym = 20   )
      parameter         (mdens   = 300  )
      parameter         (maxpq   = (mdens*(mdens+1))/2 )
      parameter         (namax   = 6    )
      parameter         (mnatom  = 86   )
      parameter         (mcycles = 1000 )
      parameter         (mirrep  = 10   )
      parameter         (msub    = 5    )
      parameter         (lmax   = (msa-1)*(msa+1) ) 
      parameter         (mairrep = 10   )
      parameter         (mpgao   = msa*mairrep*mstosym  )
      parameter         (maxmp   = 2*(msa-1) )
      parameter         (maxl    = 4*(msa-1) )
      parameter         (lmmax   = maxmp*(maxmp+2) )
      parameter         (l2mmax   = maxl*(maxl+2) )

