      program gpi
c
c.....gpi - main program unit.
c
c
      include           'implicit.inc'
      include           'global.inc'
      include           'error.inc'
      include           'stdio.inc'
      include           'strtools.inc'
c
c.....Local variables:
c
      integer           marg, mflg
      parameter         (marg = 2, mflg = 1)
      character*(ilen)  arg(marg)
      integer           lualloc
      logical           getopt, larg(marg), lflg(mflg)
      data (larg(i),i=1,marg) /marg*.false./
      data (lflg(i),i=1,mflg) /mflg*.false./
c
c.....initialize strtools in gnu compiler
c
*mdc*if gnu
      include           'strtools.ini'
*mdc*endif
c
c.....parse command line
c
      if (.not. getopt(arg, larg, marg, 'h', lflg, mflg,
     &                 null, .false., 0, null))
     &   call error ('gpi',
     &   'run program as: gpi [input [output]] [-h]', faterr)
c
c.....help:
c
      if (lflg(1)) then
         call header (stdout)
         call help (stdout)
         stop 0
      endif
c
c.....open input and output files:
c
      call ioinit ()
      if (larg(1)) then
         lur = lualloc (lur)
         la = leng (arg(1))
         open (lur, file = arg(1)(1:la), status = 'old', iostat = nios)
         if (nios .ne. 0) call error ('gpi', 'error while opening '//
     &                                arg(1)(1:la), faterr)
      else
         lur = stdin
      endif
      if (larg(2)) then
         luw = lualloc (luw)
         la = leng (arg(2))
         open (luw, file = arg(2)(1:la), status='unknown', iostat=nios)
         if (nios .ne. 0) call error ('gpi', 'error while opening '//
     &      arg(2)(1:la), faterr)
      else
         luw = stdout
      endif
      luwrite = luw
c
c.....read & interpret input file:
c
      call shell (lur, luw)
c
c.....end of run:
c
      if (lur .ne. stdin) then
         close (lur)
         call lunalloc (lur)
      endif
      if (luw .ne. stdout) then
         close (luw)
         call lunalloc (luw)
      endif
      end
