c
c-----------------------------------------------------------------------
c
      subroutine help (lus)
c
c.....help - prints out a quick reference guide in the lus logical unit.
c
      write (lus,500)
      write (lus,510)
      write (lus,520)
      write (lus,530)
      write (lus,540)
c
c.....Formats:
 500  format (/
     & 1x,'To run:     gpi [input [output]]'/
     & 1x,'gpi -h gives help'//)
 510  format (1x, '*** General orders :'/
     & 1x,'# .............. remark. Non interpreted'/
     & 1x,'copy f1 f2 ..... copy file f1 to f2'/
     & 1x,'edef fion fvac . deformation energy of fion'/
     & 1x,'end ............ end of run'/
     & 1x,'help ........... show this quick reference guide'/
     & 1x,'hf ............. set Hartree-Fock calculation (default)'/
     & 1x,'out  fout ...... print output to fout'/
     & 1x,'print nimpre ... set printing level (default: 0)'/
     & 1x,'rem ............ remark. Non interpreted'/
     & 1x,'rchf ........... set pi-rCHF calculation'/
     & 1x,'set var val .... change value of control vars'/
     & 1x,'                 Run show for a list'/
     & 1x,'show ........... list of parameters & modifiable variables'/
     & 1x,'title tit ...... use tit as title for the active ion'/
     & 1x,'uchf ........... set pi-uCHF calculation'/
     & 1x,'vacuo fion fulm fcoef (fint | fcint | fint fcint)'/
     & 1x,'          ...... calculation of an isolated ion/atom'/
     &  )
 520  format (1x, '*** Crystal shell orders :'/
     & 1x,'crystal ........ begin the pure crystal run'/
     & 1x,'endcrystal ..... end the pure crystal run'/
     & 1x,'# .............. remark. Non interpreted'/
     & 1x,'spg spaceg ..... space group of the crystal'/
     & 1x,'cell a b c alf bet gam'/
     & 1x,'   ............. unit cell geometry parameters'/
     & 1x,'title tit ...... use tit as a title for the run'/
     & 1x,'neq x y z fion fulm fcoef (fint | fcint | fint fcint) flint'/
     & 1x,'    ............ symmetry different ion in the cell'/
     & 1x,'fneq x y z xocup fion fulm fcoef (fint | fcint | fint fcint)
     & flint'/
     & 1x,'     ........... like neq, but with fractional occupancies'/
     &  )
 530  format (1x, '*** Impurity shell orders :'/
     & 1x,'impurity ....... begin the impurity run'/
     & 1x,'endimpurity .... end the impurity run'/
     & 1x,'# .............. remark. Non interpreted'/
     & 1x,'spg spaceg ..... space group of the host crystal'/
     & 1x,'cell a b c alf bet gam'/
     & 1x,'   ............. unit cell geometry parameters'/
     & 1x,'title tit ...... use tit as a title for the run'/
     & 1x,'neq x y z fion . symmetry different ion in the host cell'/
     & 1x,'fneq x y z xocup fion'/
     & 1x,'     ........... like neq, but with fractional occupancies'/
     & 1x,'neqimp npos fion fulm fcoef (fint | fcint | fint fcint)' 
     & 1x,'flint'/
     & 1x,'       {x(i) y(i) z(i)} i=1..npos'/
     & 1x,'       ......... set of equivalent impurity ions. One ion',
     &                      ' per line'/
     & 1x,'hole x y z ..... hole in the pure crystal'/
     &  )
 540  format (1x, '*** Cluster shell orders :'/
     & 1x,'cluster ........ begin the finite cluster run'/
     & 1x,'endcluster ..... end the finite cluster run'/
     & 1x,'# .............. remark. Non interpreted'/
     & 1x,'cell a b c alf bet gam'/
     & 1x,'   ............. unit cell geometry parameters'/
     & 1x,'title tit ...... use tit as a title for the run'/
     & 1x,'neqclus npos fion fulm fcoef (fint | fcint | fint fcint)
     & flint'/
     & 1x,'       {x(i) y(i) z(i)} i=1..npos'/
     & 1x,'       ......... set of equivalent cluster ions. One ion',
     &                      ' per line'/
     &  )
c
      end
