C
        SUBROUTINE INCOG(A,X,GIM)
C
C       ===================================================
C       Purpose: Compute the incomplete gama function
C                gam(a,x) 
C       Input :  a   --- Parameter ( a o 170 )
C                x   --- Argument 
C       Output:  GIM --- gam(a,x) 
C       Routine called: GAMMA for computing gam(x)
C       ===================================================
C
        include         'implicit.inc'
        include         'error.inc'

        XAM=-X+A*DLOG(X)
        IF (XAM.GT.700.0.OR.A.GT.170.0) THEN
         call error ('incog', 'a and/or x too large', faterr)
        ENDIF
        IF (X.EQ.0.0) THEN
           CALL GAMMA(A,GA)
           GIM=GA
        ELSE IF (X.LE.1.0+A) THEN
           S=1.0D0/A
           R=S
           DO K=1,60
              R=R*X/(A+K)
              S=S+R
              IF (DABS(R/S).LT.1.0D-15) GO TO 15
           ENDDO
15         GIN=DEXP(XAM)*S
           CALL GAMMA(A,GA)
           GIM=GA-GIN
        ELSE IF (X.GT.1.0+A) THEN
           T0=0.0D0
           DO K=60,1,-1
              T0=(K-A)/(1.0D0+K/(X+T0))
           ENDDO
           GIM=DEXP(XAM)/(X+T0)
        ENDIF
        END
