c
c.....densities.inc - auxiliary matrices containing the densities of
c     every ion.
c
c     denirrep() ... irrep linked with lpq
c     densub() ..... subspecies linked with lpq
c     denlp() ...... quantum angular number linked with lpq
c     denlq() ...... quantum angular number linked with lpq
c     denkp() ...... repetitions of irrep linked with lpq
c     denkq() ...... repetitions of irrep linked with lpq
c     denp() ....... STO linked with lp
c     denq() ....... STO linked with lq
c     npq() ........ sum of the n's of both STOs
c     zpq() ........ sum of the z's of both STOs
c     xpq() ........ product of the norms of the STOs
c
c     This auxiliary information facilitates building large loops, thus
c     improving vectorization and performance.
c
      integer           denirrep(mdens,mnt), densub(mdens,mnt),
     &                  denlp(mdens,mnt), denlq(mdens,mnt),
     &                  denkp(mdens,mnt), denkq(mdens,mnt),
     &                  denp(mdens,mnt), denq(mdens,mnt),
     &                  npq(mdens,mnt)
      real*8            zpq(mdens,mnt), xpq(mdens,mnt)
      common /den1/     zpq, xpq
      common /den2/     denirrep, densub
      common /den3/     denlp, denlq, denkp, denkq, denp, denq, npq
