c
c-----------------------------------------------------------------------
c
      subroutine jacsort (ndata, vector, iorden, i1, ndim)
      include           'implicit.inc'
      dimension         vector(ndim),iorden(ndim)
c
c.....jacsort - sorts an array of vectors.
c
c     vector array is sorted using direct selection algorithm.
c     Increasing ordering is used.
c
c Input:
c -----
c NDATA ...... Number of elements in VECTOR  to be ordered.
c VECTOR ..... Data array. It is not modified during the routine
c              execution.
c I1 ......... Only the first I1 elements of VECTOR are sorted out.
c NDIM ....... Total dimensions of VECTOR() and  IORDEN().
c
c Output:
c ------
c IORDEN ..... INTEGER matrix containing the order of the elements
c              of VECTOR().
c
c.....Initializes Iorden():
      do 10 i=1,ndim
         iorden(i)=i
 10   continue
c
c.....Orders the vector:
      do 15 i=1,min0(i1,ndata-1)
         k=i
         do 20 j=i+1,ndata
            if (vector(iorden(j)).lt.vector(iorden(k))) k=j
 20      continue
         idummy=iorden(k)
         iorden(k)=iorden(i)
         iorden(i)=idummy
 15   continue
      end
