c
c.....neqatm.inc - common containing information about non-equivalent
c                  ions in the primitive cell.
c
c     nneq ....... number of non-equivalent atoms in the primitive cell.
c     mult ....... multiplicity of the atoms in the unit cell.
c     zmult ...... multiplicity of the unit cell (times it contains the
c                  unit formula).
c     {x,y,z}neq . cell coordinates of the atoms.
c     xxneq(,) ... two-index matrix that is equivalenced to the single-
c                  index vectors xneq()..zneq().
c     qneq ....... charge of the atom.
c     xocup ...... fractional occupancy of the nominal positions
c                  (most usually 1, but <1 for lattices known only as an
c                  statistical average).
c     fractional . true if there are fractional occupancies.
c     namneq ..... char symbol used for the atom.
c
      integer           nneq, mult(mnt), zmult
      real*8            xneq(mnt), yneq(mnt), zneq(mnt), qneq(mnt)
      real*8            xocup(mnt), xxneq(mnt,3)
      common /neqatm/   xneq, yneq, zneq, qneq, xocup, nneq, mult, zmult
      equivalence       (xxneq(1,1), xneq(1))
      equivalence       (xxneq(1,2), yneq(1))
      equivalence       (xxneq(1,3), zneq(1))
      character*(6)     namneq(mnt)
      logical           fractional
      character*(ilen)  titrun
      common /neqat1/   namneq, titrun
      common /neqat2/   fractional
