c
c-----------------------------------------------------------------------
c
      subroutine readcoef (fichero, ni, nimpre, luw)
c
c.....readcoef - reads in from fichero the data corresponding to the
c     NI-th type of ion.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'cont.inc' 
      include           'consts.inc'
      include           'error.inc'
      include           'symmetry.inc'
      include           'neqatm.inc'
      include           'iondens.inc' 
      include           'aos.inc'
      include           'stos.inc'
      include           'coed.inc'
      include           'coup.inc'
      include           'rsh.inc'
      include           'fact.inc'
      include           'dgaunt.inc'
      include           'multipole.inc'  
c
      character*(*)     fichero
      integer           ni, nimpre, luw
c.....LOCAL VARIABLES
      integer           lualloc
      integer           lAO(maos), tmp2(maos), tmp3(maos), tmp4(maos)
      integer           girrep(maos), indaos(maos), indlaos(maos)
      integer           mmax
      parameter        (mmax=mirrep*mpgao)
      integer           lgao(mmax), kgao(mmax), pgao(mmax)
      real*8            tmp(maos), TINY
      parameter        (TINY = 1d-15)
      character*(ilen)  line, word, symmetry
      character*(ilen)  uppcase
      logical           setword 
      logical           local 

c
c.....Open the file:
c
      if (ni.gt.mnt) call error ('readcoef', 'ion # > MNT', faterr)
      if (ni.le.0)   call error ('readcoef', 'ion # <= 0', faterr)
      lui = lualloc (lui)
      open (lui, file = fichero, status = 'old', iostat = nios)
      if (nios.ne.0)
     &  call error ('readcoef', 'error while opening '//fichero, faterr)
      if (nsym(ni).gt.0) then 
c
c.....(A) Symmetry:
c
         section = 'A'
         read (lui,400,err=999,iostat=nios) line
         lp=1
         if (.not.setword(word,line,lp))
     &      call error ('readcoef', 'missing symmetry', faterr)
         symmetry=uppcase(word)
         if (symmetry(1:9).eq.'SPHERICAL') then
            local=.false.
         else if (symmetry(1:5).eq.'LOCAL') then
            local=.true.
         else
            call error ('readcoef', 'symmetry is not correct', faterr)
         endif   
         j=0 ! contador (irrep,l,k,p)
         do irrep=1,nirrep(ni)
            i=0 ! contador (l,k,p) 
            do l=0,nsym(ni)-1
               if (airrep(irrep,l,ni).gt.0) then
                  do k=1,airrep(irrep,l,ni)
                     do p=1,nsto(l+1,ni)
                        i=i+1
                        j=j+1
                        lgao(j)=l
                        kgao(j)=k
                        pgao(j)=p
                     enddo
                  enddo
               endif
            enddo
            npgao(irrep,ni)=i
         enddo 
         napgao(1,ni)=0
         nadens(1,ni)=0
         do i=1,nirrep(ni)
            ns=npgao(i,ni)
            napgao(i+1,ni)=napgao(i,ni)+ns 
            nadens(i+1,ni)=nadens(i,ni)+(ns*(ns+1))/2
            if (ns.gt.mpgao) call error ('readcoef',
     & 'too many functions adapted to the symmetry in a irrep', faterr)
         enddo
         ntpgao(ni)=napgao(nirrep(ni)+1,ni)
         ndens(ni)=nadens(nirrep(ni)+1,ni)
         if (ndens(ni).gt.mdens) call error ('readcoef',
     &    'ndens(ni) is greather than mdens', faterr)
         if (local) then ! local symmetry
c
c........(B) Title & atomic orbitals:
c
            section = 'B'
            read (lui,400,err=999,iostat=nios) tition(ni)
           read (lui,*,err=999,iostat=nios) (ngaos(i,ni),i=1,nirrep(ni))
            nagaos(1,ni)=0
            do i=1,nirrep(ni)
               nagaos(i+1,ni)=nagaos(i,ni)+ngaos(i,ni)
            enddo
            ntgaos(ni)=nagaos(nirrep(ni)+1,ni)
            if (ntgaos(ni).gt.maos) call error ('readcoef',
     &                 'too many gAOs', faterr)
          read (lui,*,err=999,iostat=nios) (ngelec(k,ni),k=1,ntgaos(ni))
           read (lui,*,err=999,iostat=nios) (georb(k,ni),k=1,ntgaos(ni))
            read (lui,*,err=999,iostat=nios)
     &     (((gc(k,j+nagaos(i,ni),ni),k=1,npgao(i,ni)),j=1,ngaos(i,ni)),
     &     i=1,nirrep(ni))
            openshell(ni)=.false.
            iao=0
            do isy=1,nirrep(ni)
               ncsh(isy,ni)=0
               nosh(isy,ni)=0
               do i=1,ngaos(isy,ni)
                  iao=iao+1
                  deg=nsub(isy,ni)*2
                  if (ngelec(iao,ni).eq.zero) then
                     nosh(isy,ni)=nosh(isy,ni)+1
                  else if (ngelec(iao,ni).eq.deg) then
                     ncsh(isy,ni)=ncsh(isy,ni)+1
                  else
                     nosh(isy,ni)=nosh(isy,ni)+1
                     openshell(ni)=.true.
                  endif
               enddo 
               if (nosh(isy,ni).gt.1) call error ('readcoef',
     &            'No more than 1 open shell per symmetry is allowed',
     &            faterr)
            enddo  
c
c........(C) Coupling constants:
c
            if (openshell(ni)) then
               section = 'C'
               read (lui,*,err=999,iostat=nios) nj, nk
               numjcoup(ni) = nj
               do jj = 1, nj
                 do lpq = 1, ndens(ni)
                   do lrs = 1, lpq
                     read (lui,*,err=999,iostat=nios) nn,xnum,xden
                     njcoup(lpq,lrs,jj,ni) = nn
                     xjcoup(lpq,lrs,jj,ni) = xnum / xden
                   enddo
                 enddo
               enddo
               numkcoup(ni) = nk
               do kk = 1, nk
                 do lpq = 1, ndens(ni)
                   do lrs = 1, lpq
                     read (lui,*,err=999,iostat=nios) nn,xnum1,xden1,
     &                                                xnum2,xden2
                     nkcoup(lpq,lrs,kk,ni) = nn
                     xkcoup(lpq,lrs,kk,1,ni) = xnum1 / xden1
                     xkcoup(lpq,lrs,kk,2,ni) = xnum2 / xden2
                   enddo
                 enddo 
               enddo
            else            
               numjcoup(ni) = 0
               numkcoup(ni) = 0
            endif
c
c........(D) Energies:
c
            section = 'D'
         read (lui,*,err=999,iostat=nios) eeff(ni), eadd(ni), ecorr(ni),
     &                                    ekin(ni), epot(ni)
            eint(ni) = 2d0 * (eeff(ni) - eadd(ni))
         else ! spherical symmetry to obtain guess
            if (openshell(ni)) call error ('readcoef',
     &         'there are openshells', faterr)        
c
c........Obtention of gOAs for each irrep
c
            do irrep=1,nirrep(ni)
               ngaos(irrep,ni)=0
               do l=1,nsym(ni)
                  ngaos(irrep,ni)=ngaos(irrep,ni)
     &                            +airrep(irrep,l-1,ni)*naos(l,ni) 
               enddo
            enddo   
            nagaos(1,ni)=0
            do i=1,nirrep(ni)
               nagaos(i+1,ni)=nagaos(i,ni)+ngaos(i,ni)
            enddo
            ntgaos(ni)=nagaos(nirrep(ni)+1,ni)
            if (ntgaos(ni).gt.maos) call error ('readcoef',
     &                'too many gAOs', faterr)
            itot1=0 ! spherical symmetry
            do l=1,nsym(ni)
               itot1=itot1+naos(l,ni)*(l+l-1)
            enddo
            itot2=0 ! local symmetry
            do i=1,nirrep(ni)
               itot2=itot2+ngaos(i,ni)*nsub(i,ni)
            enddo
            if (itot1.ne.itot2) call error ('readcoef',
     &          'inapropiate number of gAOs', faterr) 
c
c........Obtention orbital energies and electron population
c
            k=0 ! contador AOs
            do l=1,nsym(ni)
               do i=1,naos(l,ni)
                  k=k+1
                  lAO(k)=l-1
               enddo
            enddo 
            ig=0 ! contador gAOs
            do k=1,ntaos(ni)
               l=lAO(k)
               do i=1,nirrep(ni)
                  if (airrep(i,l,ni).gt.0) then
                     do j=1,airrep(i,l,ni)
                        ig=ig+1
                        tmp(ig)=eorb(k,ni) ! orbital energy
                        tmp2(ig)=i ! irrep
                        tmp3(ig)=k ! AO related with gAO
                        tmp4(ig)=l ! AO angular momentum
                     enddo
                  endif
               enddo
            enddo
            if (ig.ne.ntgaos(ni)) call error ('readcoef',
     &          'inapropiate number of gAOs', faterr)
            ig=0 ! contador gAOs (well-organized)
            do i=1,nirrep(ni)
               do k=1,ntgaos(ni)
                  irrep=tmp2(k)
                  if (irrep.eq.i) then
                     ig=ig+1
                     ngelec(ig,ni)=2*nsub(irrep,ni)
                     georb(ig,ni)=tmp(k) ! orbital energy
                     girrep(ig)=irrep    ! irrep
                     indaos(ig)=tmp3(k)  ! AO related with gAO
                     indlaos(ig)=tmp4(k) ! AO angular momentum
                  endif
               enddo
            enddo       
c
c........Obtention orbital coefficients
c
            do j=1,ntgaos(ni)
               la=indlaos(j)
               nn=indaos(j)
               irrep=girrep(j)
               i=0 ! contador (l,k,p)
               do l=0,nsym(ni)-1
                  if (airrep(irrep,l,ni).gt.0) then
                     do k=1,airrep(irrep,l,ni)
                        do p=1,nsto(l+1,ni)
                           i=i+1
                           if (l.eq.la) then
                              gc(i,j,ni)=c(p,nn,ni)
                           else
                              gc(i,j,ni)=zero
                           endif
                        enddo
                     enddo
                  endif 
               enddo
            enddo   
            iao=0
            do isy=1,nirrep(ni)
               ncsh(isy,ni)=0
               nosh(isy,ni)=0
               do i=1,ngaos(isy,ni)
                  iao=iao+1
                  deg=nsub(isy,ni)*2
                  if (ngelec(iao,ni).eq.deg) then
                     ncsh(isy,ni)=ncsh(isy,ni)+1
                  else
                     call error ('readcoef',
     &                          'nosh is not equal to zero', faterr)
                  endif
               enddo
            enddo
         endif 
c
c.....Store the number of densities charge associated with each irrep  
c
         do irrep = 1, nirrep(ni)
           ndensym(irrep,ni) = npgao(irrep,ni)*(npgao(irrep,ni)+1)/2
         enddo
c
c.....Store densities (and symmetries) into auxiliary matrices:
c
         lpq=0
         do irrep=1,nirrep(ni)            
            do ip=1,npgao(irrep,ni)
               ip1=ip+napgao(irrep,ni)
               lp=lgao(ip1)
               kp=kgao(ip1)
               istop=pgao(ip1)
               do iq=1,ip
                  lpq=lpq+1
                  iq1=iq+napgao(irrep,ni)
                  lq=lgao(iq1)
                  kq=kgao(iq1)
                  istoq=pgao(iq1)
                  denirrep(lpq,ni)=irrep
                  densub(lpq,ni)=nsub(irrep,ni) 
                  denlp(lpq,ni)=lp
                  denkp(lpq,ni)=kp
                  denp(lpq,ni)=istop
                  ip2=istop+nasto(lp+1,ni)
                  denlq(lpq,ni)=lq
                  denkq(lpq,ni)=kq
                  denq(lpq,ni)=istoq
                  iq2=istoq+nasto(lq+1,ni)
                  npq(lpq,ni)=n(ip2,ni)+n(iq2,ni)
                  zpq(lpq,ni)=z(ip2,ni)+z(iq2,ni)
                  xpq(lpq,ni)=xnsto(ip2,ni)*xnsto(iq2,ni)
               enddo 
            enddo
         enddo
c
c.....Store coefUm coefficients:
c
         do lpq=1,ndens(ni)
            irrep=denirrep(lpq,ni)
            ns=densub(lpq,ni)
            lp=denlp(lpq,ni)
            ilp=il0(lp)
            kp=denkp(lpq,ni)
            lq=denlq(lpq,ni)
            ilq=il0(lq)
            kq=denkq(lpq,ni)
            do mp=-lp,lp
               lmp=ilp+mp
               do mq=-lq,lq
                  lmq=ilq+mq
                  coefUm(lpq,mp,mq,ni)=zero
                  do isub=1,ns
                     coefUm(lpq,mp,mq,ni)=coefUm(lpq,mp,mq,ni)+
     &               coefu(irrep,isub,kp,lmp)*coefu(irrep,isub,kq,lmq)
                  enddo 
                  coefUm(lpq,mp,mq,ni)=coefUm(lpq,mp,mq,ni)/ns
               enddo
            enddo
         enddo
c
c.....Store udpq & qmult coefficients:
c
         nlm(ni) = 4*nsym(ni)*(nsym(ni)-1)
         do lpq=1,ndens(ni)
            lp = denlp(lpq,ni)
            lp0 = il0(lp)
            lq = denlq(lpq,ni)
            lq0 = il0(lq)
            lmenos=abs(lp-lq)
            lmas=lp+lq
            mlmin(lpq,ni) = lmenos
            dmlmin(lpq,ni) = il0(lmenos) - lmenos ! lmenos^2
            dmlmax(lpq,ni) = il0(lmas) + lmas ! lmas*(lmas+2)
            do lm=dmlmin(lpq,ni),dmlmax(lpq,ni)
               udpq(lpq,lm,ni) = zero
               qmult(lpq,lm,ni) = zero
            enddo
            do l=lmenos,lmas,2
               l0=il0(l)
               do mp=-lp,lp
                  lmp = lp0 + mp
                  do mq=-lq,lq
                     lmq = lq0 + mq
                     i = ig0(lmp,lmq,l)
                     Umpmq = coefUm(lpq,mp,mq,ni)
                     do im = 1, m3num(mp,mq,l)
                        i = i+1
                        lm = l0 + m3val(mp,mq,im)
                        udpq(lpq,lm,ni) = udpq(lpq,lm,ni)
     &                                  + Umpmq * dgaunt(i)
                     enddo
                  enddo 
               enddo
               do lm = l0-l, l0+l
                  if (abs(udpq(lpq,lm,ni)).le.TINY)
     &               udpq(lpq,lm,ni) = zero
                  if (udpq(lpq,lm,ni).ne.zero) then
                     qmult(lpq,lm,ni) = udpq(lpq,lm,ni) * xncte(l)
     &                        * xpq(lpq,ni) * fact(npq(lpq,ni)+l)
     &                        / zpq(lpq,ni)**(npq(lpq,ni)+l+1)
                  endif
               enddo
            enddo ! l
         enddo ! lpq    
      else
         napgao(1,ni) = 0
         ntpgao(ni)   = 0
         ndens(ni)    = 0
         nlm(ni)      = 0
         nagaos(1,ni) = 0
         ntgaos(ni)   = 0
      endif 
c
c.....close the data file:
c
      close (lui)
      call lunalloc (lui)
c
c.....Print-out:
c
      if (nimpre .lt. 0) return
c
      write (luw,500) ni, fichero, tition(ni), namneq(ni), zn(ni)
      do i = 1, nirrep(ni)
         write (luw,530) label(i,ni), nsub(i,ni)
         write (luw,560) (ngelec(j+nagaos(i,ni),ni), j = 1, ngaos(i,ni))
         write (luw,570) (georb(j+nagaos(i,ni),ni), j = 1, ngaos(i,ni))
         write (luw,580)
         do k = 1, npgao(i,ni)
           write (luw,590) (gc(k,j+nagaos(i,ni),ni),j = 1,ngaos(i,ni))
         enddo
      enddo
      if (openshell(ni)) then
         write (luw,300) 'J & K coupling constants'
         do j = 1, numjcoup(ni)
           do lpq = 1, ndens(ni)
             do lrs = 1, lpq
               write (luw,310) 'J', njcoup(lpq,lrs,j,ni),
     &                          xjcoup(lpq,lrs,j,ni)
             enddo
           enddo  
         enddo
         do k = 1, numkcoup(ni)
           do lpq = 1, ndens(ni)
             do lrs = 1, lpq
               write (luw,320) 'K', nkcoup(lpq,lrs,k,ni),
     &         xkcoup(lpq,lrs,k,1,ni), xkcoup(lpq,lrs,k,2,ni)
             enddo
           enddo  
         enddo
      endif
      write (luw,565)
c
c.....Normal end:
c
      return
c
c.....Error while reading:
c
 999  write (luw,610) ni, fichero(1:leng(fichero)), nios, section
      close (lui)
      call lunalloc (lui)
      call error ('readcoef', 'error reading coef type file', faterr)
      return
c
c.....Formats:
c
 400  format (a)
 500  format (1x,'Reading description for atom #',i3,' from file ',a/
     & 1x,a/ 1x,a6,4x,'Atomic number:',f16.6)
 530  format (/1x,'Symmetry  ',a,1x,'degeneration ',i3)
 560  format (1x,'Elec population',8f12.5)
 565  format (/)
 570  format (1x,'BASIS / ORB.E. ',8f12.5)
 580  format (1x,'ORB. COEFFICIENTS:')
 590  format (1x,8f12.8)
 300  format (/1x, 'Open shell energy formula: ', a)
 310  format (1x, a1, '(', i2, ')=', 1pe15.8)
 320  format (1x, a1, '(', i2, ')=', 2pe15.8)
 610  format (1x,'Reading error (Ion#, File, Ion):',i2,4x,a,i6/
     &        1x,'  in section ',a1,' of the ionic file'/)
c
      end
