c
c-----------------------------------------------------------------------
c
      subroutine readion (fichero, ni, nimpre, luw)
c
c.....readion - reads in from fichero the data corresponding to the
c     NI-th type of ion.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'aos.inc'
      include           'intg.inc'
      include           'vef.inc'
      include           'cont.inc'
      include           'consts.inc'
      include           'coup.inc'
      include           'iondens.inc'
      include           'error.inc'
      include           'files.inc'
      include           'fact.inc'
      include           'neqatm.inc'
      include           'stos.inc'
      include           'strtools.inc'
c
      character*(*)     fichero
      integer           ni, nimpre, luw
c
      integer           ip, iq, lualloc
      character*(ilen)  line, word, word2, piversion, basistype
      character*(ilen)  uppcase
      character*(1)     section
      logical           setword, setdble
c
c.....Open the file:
c
      if (ni.gt.mnt) call error ('readion', 'ion # > MNT', faterr)
      if (ni.le.0)   call error ('readion', 'ion # <= 0', faterr)
      lui = lualloc (lui)
      open (lui, file = fichero, status = 'old', iostat = nios)
      if (nios.ne.0)
     &  call error ('readion', 'error while opening '//fichero, faterr)
c
c.....(A) Descriptive data:
c
      section = 'A'
      read (lui,400,err=999,iostat=nios) line
      lp = 1
      if (.not. setword (word, line, lp))
     &   call error ('readion', 'missing pi version number', faterr)
      piversion = uppcase (word)
      if (piversion(1:3) .ne. 'GPI')
     &   call error ('readion',
     &      'only GPI ionic files are supported in this program',
     &      faterr)
      if (.not. setword (word, line, lp))
     &   call error ('readion', 'missing basis type', faterr)
      basistype = uppcase (word)
      if (basistype(1:3) .ne. 'STO') call error ('readion',
     &   'only STOs are supported in this program', faterr)
c
c.....(B) Titles & symmetries:
c
      section = 'B'
      read (lui,400,err=999,iostat=nios) tition(ni)
      read (lui,400,err=999,iostat=nios) line
      lp = 1
      if (.not. setword (word2, line, lp))
     &   call error ('readion', 'empty ionic name', faterr)
      word = uppcase (word2)
      lw = leng(word)
      namneq(ni) = word(1:lw)
      if (.not. setdble (zn(ni), line, lp)) call error ('readion',
     &       'atomic number has not been correctly given', faterr)
      read (lui,*,err=999,iostat=nios) nsym(ni)
      if (nsym(ni).lt.0 .or. nsym(ni).gt.msa) call error ('readion',
     &     'inapropriate number of symmetries', faterr)
      if (nsym(ni).gt.0) then
c
c
c........(C) Basis set:
c
         section = 'C'
         read (lui,*,err=999,iostat=nios) (nsto(i,ni),i=1,nsym(ni))
         nasto(1,ni)=0
         do i=1,nsym(ni)
            ns=nsto(i,ni)
            nasto(i+1,ni)=nasto(i,ni)+ns
            if (ns.gt.mstosym) call error ('readion',
     &            'too many STOs in a symmetry', faterr)
         enddo
         ntsto(ni)=nasto(nsym(ni)+1,ni)
         if (ntsto(ni).gt.msto) call error ('readion', 
     &            'too many STOs', faterr)
         read (lui,*,err=999,iostat=nios) (n(k,ni),k=1,ntsto(ni))
         read (lui,*,err=999,iostat=nios) (z(k,ni),k=1,ntsto(ni))
         do k=1,ntsto(ni)
            nk2=n(k,ni)*2
            xnsto(k,ni)=sqrt((two*z(k,ni))**(nk2+1)/fact(nk2))
         enddo
c
c........(D) Atomic orbitals:
c
         section = 'D'
         read (lui,*,err=999,iostat=nios) (naos(i,ni),i=1,nsym(ni))
         naaos(1,ni)=0
         do i=1,nsym(ni)
            naaos(i+1,ni)=naaos(i,ni)+naos(i,ni)
         enddo
         ntaos(ni)=naaos(nsym(ni)+1,ni)
         if (ntaos(ni).gt.maos) call error ('readion',
     &             'too many AOs', faterr)
         read (lui,*,err=999,iostat=nios) (nelec(k,ni),k=1,ntaos(ni))
         read (lui,*,err=999,iostat=nios) (eorb(k,ni),k=1,ntaos(ni))
         read (lui,*,err=999,iostat=nios)
     &        (((c(k,j+naaos(i,ni),ni),k=1,nsto(i,ni)),j=1,naos(i,ni)),
     &        i=1,nsym(ni))
         openshell(ni) = .false.
         iao = 0
         do isy = 1, nsym(ni)
            ncsh(isy,ni) = 0
            nosh(isy,ni) = 0
            do i = 1, naos(isy,ni)
               iao = iao + 1
               deg = (2 * isy - 1) * 2
               if (nelec(iao,ni).eq.zero) then
                  nosh(isy,ni) = nosh(isy,ni) + 1
               else if (nelec(iao,ni).eq.deg) then
                  ncsh(isy,ni) = ncsh(isy,ni) + 1
               else
                  nosh(isy,ni) = nosh(isy,ni) + 1
                 openshell(ni) = .true.
               endif
            enddo
            if (nosh(isy,ni) .gt. 1) call error ('readion',
     &         'No more than 1 open shell per symmetry is allowed',
     &         faterr)
         enddo
      else
         nasto(1,ni) = 0
         ntsto(ni)   = 0
         naaos(1,ni) = 0
         ntaos(ni)   = 0
      endif 
c
c.....(E) Energies:
c
      section = 'E'
      read (lui,*,err=999,iostat=nios) eeff(ni), eadd(ni), ecorr(ni),
     &                                 ekin(ni), epot(ni)
      eint(ni) = two * (eeff(ni) - eadd(ni))
c
c.....close the data file:
c
      close (lui)
      call lunalloc (lui)
c
c.....Determine the net charge of the ion:
c
      qnet = zn(ni)
      if (nsym(ni).gt.0) then
         do i = 1, ntaos(ni)
            qnet = qnet - nelec(i,ni)
         enddo
      endif 
      qclas(ni) = qnet
c
c.....Print-out:
c
      if (nimpre .lt. 0) return
c
      write (luw,500) ni, fichero, tition(ni), namneq(ni), zn(ni),
     &                qclas(ni)
c
      if (nimpre .eq. 0) return
c
      do i=1,nsym(ni)
         write (luw,510) i
         write (luw,515) (nelec(j+naaos(i,ni),ni),j=1,naos(i,ni))
         write (luw,520) (eorb(j+naaos(i,ni),ni),j=1,naos(i,ni))
         do k=1,nsto(i,ni)
            k1=k+nasto(i,ni)
            write (luw,530) n(k1,ni),z(k1,ni),
     &                  (c(k,j+naaos(i,ni),ni),j=1,naos(i,ni))
         enddo
      enddo
      enet = eeff(ni) - eint(ni)
      if (ekin(ni) .gt. zero) then
         vir  = epot(ni)/ekin(ni)
      else
         vir = zero
      endif
      write (luw,535) eeff(ni), eint(ni), enet, eadd(ni), vir
      write (luw,560)
c
c.....Normal end:
c
      return
c
c.....Error while reading:
c
 999  write (luw,600) ni, fichero(1:leng(fichero)), nios, section
      close (lui)
      call lunalloc (lui)
      call error ('readion', 'error reading ion type file', faterr)
      return
c
c.....Formatos:
c
 400  format (a)
 500  format (1x,'Reading description for atom #',i3,' from file ',a/
     & 1x,a/ 1x,a6,4x,'Atomic number:',f16.6,4x,'Net charge:',f16.6)
 510  format (/1x,'Symmetry  ',i3)
 515  format (1x,'Elec population',8f12.5)
 520  format (1x,'BASIS / ORB.E. ',8f12.5)
 530  format (1x,i2,f15.6,1x,8f12.8)
 535  format (/1x, 'Effective energy    =', 1pe15.8/
     &         1x, 'Interaction energy  =', 1pe15.8/
     &         1x, 'Net energy          =', 1pe15.8/
     &         1x, 'Additive energy     =', 1pe15.8/
     &         1x, 'Virial              =', 1pe15.8)
 560  format (/)
 600  format (1x,'Reading error (Ion#, File, Ion):',i2,4x,a,i6/
     &        1x,'  in section ',a1,' of the ionic file'/)
c
      end
