c
c-----------------------------------------------------------------------
c
      subroutine readulm (fichero, ni, nimpre, luw)
c
c.....readulm - reads in from fichero the data corresponding to the
c     NI-th type of ion.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'celatm.inc'
      include           'neqatm.inc'
      include           'cont.inc'
      include           'consts.inc'
      include           'error.inc'
      include           'rsh.inc'
      include           'symmetry.inc'
c
      character*(*)     fichero
      integer           ni, nimpre, luw
c.....LOCAL VARIABLES
      integer           iaux(mirrep,0:msa-1)
      integer           isub(mirrep,0:msa-1,mairrep)
      integer           lp, lnumb
      integer           lualloc
      real*8            u(0:msa-1,-msa+1:msa-1,2*msa-1)
      real*8            TINY
      parameter        (TINY = 1d-8)
      character*(6)     lab, lab2
      character*(ilen)  lowcase, line
      logical           setint 

c
c.....Open the file:
c
      if (ni.gt.mnt) call error ('readulm', 'ion # > MNT', faterr)
      if (ni.le.0)   call error ('readulm', 'ion # <= 0', faterr)
      lui = lualloc (lui)
      open (lui, file = fichero, status = 'old', iostat = nios)
      if (nios.ne.0)
     &  call error ('readulm', 'error while opening '//fichero, faterr)
c
c.....Initializations
c
      if (nsym(ni).gt.0) then
         do i=1,mirrep
            do l=0,nsym(ni)-1
               iaux(i,l)=0
               airrep(i,l,ni)=0
               do k=1,mairrep
                  isub(i,l,k)=0
               enddo 
            enddo
         enddo   
c
c.....(A) Irreps and subspecies:
c
         section = 'A'
         read (lui,400,err=999,iostat=nios) line
         lp = 1
         if (.not. setint (nirrep(ni), line, lp)) then
           call error ('readulm', 
     &           'number of irreps is not specified', faterr)
         endif
         if (nirrep(ni).le.0 .or. nirrep(ni).gt.mirrep) then
            call error ('readulm',
     &            'inapropriate number of irreps', faterr)
         endif
         if ( .not. setint (lnumb, line, lp)) then
            call error ('readulm', 
     &       'nsym omitted: we use the obtained in readion', noerr)
         else
            if (lnumb.ne.nsym(ni)) call error ('readulm',
     &      'nsym is different to that obtained in readion', faterr)
         endif
         read (lui,*,err=999,iostat=nios) (nsub(i,ni),i=1,nirrep(ni)) 
         do i=1,nirrep(ni) 
            if (nsub(i,ni).gt.msub) call error ('readulm',
     &               'too many subspecies of symmetry', faterr)
            if (nsub(i,ni).le.0) call error ('readulm',
     &            'inapropriate number of subspecies', faterr)  
         enddo
         read (lui,*,err=999,iostat=nios) (label(i,ni),i=1,nirrep(ni))
         do i=1,nirrep(ni)
            label(i,ni)=lowcase(label(i,ni))
         enddo 
         do i=2,nirrep(ni)
            lab=label(i,ni)
            do j=1,i-1
               lab2=label(j,ni)
               if (lab.eq.lab2) then
                  call error ('readulm',
     &               'There are irreps with same name', faterr)
               endif
            enddo
         enddo   
c
c.....(B) Coefficients of symmetry for angular functions:
c
         section = 'B'
         do l=0,nsym(ni)-1 ! Slm basis (m<=|l|)
            il=il0(l)
            do ki=1,l+l+1 ! files related with Slm basis
               read(lui,*,err=999,iostat=nios) lab,(u(l,m,ki),m=-l,l)
               lab=lowcase(lab)
               ntm=0
               do i=1,nirrep(ni)
                  lab2=label(i,ni)
                  if (lab.eq.lab2) then
                     iaux(i,l)=iaux(i,l)+1
                     irrep=i
                     xnum=real(iaux(i,l))/real(nsub(i,ni))-TINY
c                    airrep(i,l,ni): repetitions of irreps in Slm basis                  
                     krep=int(xnum)+1
                     airrep(i,l,ni)=krep
                     if (krep.gt.mairrep) then
                        call error ('readulm',
     & 'too many repetitions of irreps in the real spherical harmonics',
     &  faterr)
                     endif
                     ntm=1
                  endif
               enddo   
               if (ntm.eq.0) call error ('readulm',
     &                       'incorrect name of irrep', faterr)
               do kf=1,ki
                  aux=zero
                  do m=-l,l
                     aux=aux+u(l,m,ki)*u(l,m,kf)
                  enddo
                  if (ki.ne.kf) then
                     if (abs(aux-zero).gt.TINY) call error ('readulm',
     &            'coefficients of symmetry are not orthogonal', faterr)
                     if (aux.lt.zero) call error ('readulm',
     &             'coefficients of symmetry are incorrect', faterr)
                  else ! ki .eq. kf
                     if (abs(aux-zero).lt.TINY) call error ('readulm',
     &             'coefficients of symmetry are incorrect', faterr)
                     if (aux.lt.zero) call error ('readulm',
     &             'coefficients of symmetry are incorrect', faterr)
                     if (abs(aux-one).gt.TINY) then
                        call error ('readulm',
     &          'coefficients of symmetry are not normalized', warning) 
                        do m=-l,l
                           u(l,m,ki)=u(l,m,ki)/sqrt(aux)
                        enddo
                     endif
                  endif  
               enddo  
               isub(irrep,l,krep)=isub(irrep,l,krep)+1
               ksub=isub(irrep,l,krep)
               if (ksub.gt.nsub(irrep,ni)) then
                  call error ('readulm',
     &  'inapropiate number of subspecies in ulm coefficients', faterr)
               endif
               do m=-l,l
                  lm=il+m
                  coefu(irrep,ksub,krep,lm)=u(l,m,ki)
               enddo
            enddo
            do i=1,nirrep(ni)
               do k=1,mairrep
                  if (isub(i,l,k).ne.0) then
                   if (isub(i,l,k).ne.nsub(i,ni)) call error ('readulm',
     & 'inapropiate number of subspecies in ulm coefficients', faterr) 
                  endif
               enddo
            enddo 
         enddo
      else
         nirrep(ni) = 0
      endif   
c
c.....close the data file:
c
      close (lui)
      call lunalloc (lui)
c
c.....Print-out:
c
      if (nimpre .lt. 0) return
c
      write (luw,500) ni, fichero, namneq(ni), zn(ni)
      do i = 1, nirrep(ni)
         issub = nsub(i,ni)
         write (luw,530) label(i,ni),issub
         write (luw,540)
         do j=1,issub
            do l=0,nsym(ni)-1
               lmsub=il0(l)-l
               lmadd=il0(l)+l
               if (airrep(i,l,ni).gt.0) then
                  do k=1,airrep(i,l,ni)
                     write (luw,550) j,l,k,
     &               (coefu(i,j,k,lm),lm=lmsub,lmadd)
                  enddo 
               endif
            enddo
         enddo
      enddo   
      write (luw,560)
c
c.....Normal end:
c
      return
c
c.....Error while reading:
c
 999  write (luw,600) ni, fichero(1:leng(fichero)), nios, section
      close (lui)
      call lunalloc (lui)
      call error ('readulm', 'error reading ulm type file', faterr)
      return
c
c.....Formats:
c
 400  format (a)
 500  format (1x,'Reading description for atom #',i3,' from file ',a/
     & 1x,a6,4x,'Atomic number:',f16.6)
 530  format (/1x,'Symmetry  ',a,1x,'degeneration ',i3)
 540  format (1x,'Coefficients for angular functions adapted',/,1x,
     &           'to the symmetry:')
 550  format (1x,'Subspecies ',i3,1x,'angular momentum ',i3,1x,
     & 'repetition ',i3,/,8f12.5)
 560  format (/)
 600  format (1x,'Reading error (Ion#, File, nios) :',i2,4x,a,1x,i6/
     &        1x,'   in section ',a1,' of the ionic file'/) 
c     
      end
