      subroutine rotmat (indrot, indm)
c
c.....rotmat - compute the rotation matrices for RSHs up to order maxmp
c
      include           'implicit.inc'
      include           'global.inc'
      include           'consts.inc'
      include           'rotmat.inc'
      include           'spgcom.inc'
c
c.....parameters:
c     indrot ... index to store the rotation matrices for RSHs, R^l  
c     indm ...   proper rotation rotm(3,3,indm) for cartesian
c                coordinates; it should act over column (x,y,z) vectors
c
      integer           indrot, indm
c
      integer           i, i1, i2, l, m1, m2
c
c.....rotation matrices for l=0 and l=1; mod(m+2,3)+1 transforms
c     m=(-1,0,1) into i=(2,3,1), i.e., (y,z,x)
c
c     irot0()........ pointer to first element of R^l in rotr (), which
c                     is 1+l*(2l-1)*(2l+1)/3
      irot0(0) = 1
      rotr(1,indrot) = one !R_{0,0}^0=1
      i = 2
      irot0(1) = 2
      do m2 = -1, 1
        i2 = mod(m2+2,3) + 1
        do m1 = -1, 1
          i1 = mod(m1+2,3) + 1
c         R_{-1,-1}^1=rotop(2,2,neq1)(i=2);R_{0,-1}^1=rotop(3,2,neq1)(i=3)
c         R_{1,-1}^1=rotop(1,2,neq1)(i=4);R_{-1,0}^1=rotop(2,3,neq1)(i=5) 
c         R_{0,0}^1=rotop(3,3,neq1)(i=6);R_{1,0}^1=rotop(1,3,neq1)(i=7)
c         R_{-1,1}^1=rotop(2,1,neq1)(i=8);R_{0,1}^1=rotop(3,1,neq1)(i=9)
c         R_{1,1}^l=rotop(1,1,neq1)(i=10)
          rotr(i,indrot) = rotm(i1,i2,indm)
          i = i + 1
        enddo
      enddo
c
c.....loop over l values, obtaining each R^l by recurrence from R^(l-1)
c
      do l = 2, maxmp
        irot0(l) = irot0(l-1) + (l+l-1)*(l+l-1)
        call rotrecur (rotr(irot0(1),indrot),rotr(irot0(l-1),indrot),
     &                 rotr(irot0(l),indrot),l)
      enddo
c
c.....end of routine
c
      return
      end
