      subroutine rshinit ()
c
c.....rshinit - fill matrices related to real spherical harmonics (RSH)
c
      include           'implicit.inc'
      include           'global.inc'
      include           'dgaunt.inc'
      include           'rsh.inc'
c
c.....compute il0() indices for access to rsh() matrices
c     il0(l) = l*(l+1)
c
      il0(0) = 0
      il = 0
      do l = 1, maxl
        il = il + l + l
        il0(l) = il
      enddo
c
c.....fill auxiliar indices for the dgaunt data structures
c
      do m1 = -maxmp, maxmp
        do m2 = -maxmp, maxmp
          mp = m1 * m2
          ms = m1 + m2
          msabs = abs(ms)
c.........cases b, d, i
          if (mp.eq.0) then
            m3val(m1,m2,1) = ms
            do l3 = 0, msabs-1
              m3num(m1,m2,l3) = 0
            enddo
            do l3 = msabs, maxl
              m3num(m1,m2,l3) = 1
            enddo
c.........cases a, j
          else if (mp.gt.0) then
            mrabs = abs(m1-m2)
            m3val(m1,m2,1) = mrabs
            m3val(m1,m2,2) = msabs
            do l3 = 0, mrabs-1
              m3num(m1,m2,l3) = 0
            enddo
            do l3 = mrabs, msabs-1
              m3num(m1,m2,l3) = 1
            enddo
            do l3 = msabs, maxl
              m3num(m1,m2,l3) = 2
            enddo
c.........case j
          else
            mrabs = abs(m1-m2)
            if (msabs.eq.0) then
              m3val(m1,m2,1) = -mrabs
              do l3 = 0, mrabs-1
                m3num(m1,m2,l3) = 0
              enddo
              do l3 = mrabs, maxl
                m3num(m1,m2,l3) = 1
              enddo
            else
              m3val(m1,m2,1) = -msabs
              m3val(m1,m2,2) = -mrabs
              do l3 = 0, msabs-1
                m3num(m1,m2,l3) = 0
              enddo
              do l3 = msabs, mrabs-1
                m3num(m1,m2,l3) = 1
              enddo
              do l3 = mrabs, maxl
                m3num(m1,m2,l3) = 2
              enddo
            endif
          endif
        enddo
      enddo
c
c.....compute the dgaunt matrix
c
      i = 0 ! contador que aglutina (l1,m1,l2,m2,l3,m3)
      l1 = 0 ! l1 = 0,...,maxmp 
      do lm1 = 0, lmmax ! lm1 = il0(l1)+m1; lm1(max) =
                        !                   l1*(l1+2) 
        if (lm1.gt.il0(l1)+l1) l1 = l1 + 1
        m1 = lm1 - il0(l1) ! m1 = -l1,...,l1
        l2 = 0 ! l2 = 0,...,maxmp
        do lm2 = 0, lm1 ! lm2 = il0(l2)+m2; lm2(max) = lm1
          if (lm2.gt.il0(l2)+l2) l2 = l2 + 1
          m2 = lm2 - il0(l2) ! m2 = -l2,...,l2
          do l3 = l1-l2, l1+l2, 2 ! Desigualdad triangular
            ig0(lm1,lm2,l3) = i
            ig0(lm2,lm1,l3) = i ! d_{l1m1,l2m2}^{l3m3} =
                                ! d_{l2m2,l1m1}^{l3m3}
            do im3 = 1, m3num(m1,m2,l3)
              i = i + 1
              m3 = m3val(m1,m2,im3) ! m3 = -l3,...,l3
              dgaunt(i) = rgaunt (l1,m1,l2,m2,l3,m3)
            enddo
          enddo
        enddo
      enddo
c
c.....end
c
      return
      end
