c
c-----------------------------------------------------------------------
c
      subroutine scfout (ni, luw)
c
c.....scfout - prints out the SCF results.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'cont.inc'
      include           'coup.inc'
      include           'consts.inc'
      include           'intg.inc'
      include           'lint.inc'
      include           'neqatm.inc'
      include           'scf.inc'
      include           'symmetry.inc' 
c
      integer           ni
c
      real*8            tob(maos), uob(maos), vmpob(maos), vnsrob(maos),
     &                  vesrob(maos), vexob(maos), plaob(maos), e1e, e2e
c
c.....print out headings and state:
c
      write (luw,500)
      write (luw,510) tition(ni), namneq(ni), zn(ni)
      write (luw,525) 'Slater-type'
      if (openshell(ni)) then
         write (luw,520) 'J & K coupling constants'
         do lpq = 1, ndens(ni)
           do lrs = 1, lpq
             do j = 1, numjcoup(ni)
               write (luw,521) 'J', lpq, lrs, njcoup(lpq,lrs,j,ni),
     &                          xjcoup(lpq,lrs,j,ni)
             enddo
           enddo
         enddo
         do lpq = 1, ndens(ni)
           do lrs = 1, lpq 
             do k = 1, numkcoup(ni)
               write (luw,522) 'K', lpq, lrs, nkcoup(lpq,lrs,k,ni),
     &         xkcoup(lpq,lrs,k,1,ni), xkcoup(lpq,lrs,k,2,ni)
             enddo
           enddo 
         enddo
      endif
c
c.....print out orbital description:
c
      do i=1,nirrep(ni)
         write (luw,530) i, label(i,ni)
         write (luw,535) (ngelec(j+nagaos(i,ni),ni),j=1,ngaos(i,ni))
         write (luw,540) (georb(j+nagaos(i,ni),ni),j=1,ngaos(i,ni))
         do k=1,npgao(i,ni)
            k1=k+napgao(i,ni)
            write (luw,550) (gc(k,j+nagaos(i,ni),ni),j=1,ngaos(i,ni))
         enddo
      enddo
c
c.....print out contributions to the orbital energies:
c
      write (luw,600)
      do k = 1, maos
         tob(k) = zero
         uob(k) = zero
         vmpob(k)  = zero
         vnsrob(k) = zero
         vesrob(k) = zero
         vexob(k)  = zero
         plaob(k)  = zero
      enddo
      k = 0
      do l = 1, nirrep(ni)
         do i = 1, npgao(l,ni)
            do j = 1, i
               k = k + 1
               factor = two
               if (i .eq. j) factor = one
               do nn = 1, ngaos(l,ni)
                  nn1 = nn + nagaos(l,ni)
                  dij = factor * gc(i,nn1,ni) * gc(j,nn1,ni)
                  tob(nn1) = tob(nn1) + dij * t(k)
                  uob(nn1) = uob(nn1) + dij * u(k)
                  vmpob(nn1)  = vmpob(nn1)  + dij * vmp(k)
                  vnsrob(nn1) = vnsrob(nn1) + dij * vnsr(k)
                  vesrob(nn1) = vesrob(nn1) + dij * vesr(k)
                  vexob(nn1)  = vexob(nn1)  + dij * vex(k)
                  plaob(nn1)  = plaob(nn1)  + dij * pla(k)
               enddo
            enddo
         enddo
      enddo
      do l = 1, nirrep(ni)
         do nn = 1, ngaos(l,ni)
            nn1 = nn + nagaos(l,ni)
            e1e = tob(nn1) + uob(nn1) + vmpob(nn1) + vnsrob(nn1) +
     &            vesrob(nn1) + vexob(nn1) + plaob(nn1)
            e2e = georb(nn1,ni) - e1e
            write (luw,610) nn, label(l,ni), tob(nn1), uob(nn1),
     &                      e2e, vmpob(nn1), vnsrob(nn1), vesrob(nn1),
     &                      vexob(nn1), plaob(nn1)
         enddo
      enddo
c
      write (luw,560) thrscf,nitscf
      enet = eeff(ni) - eint(ni)
      if (ekin(ni).gt.0d0) then
        virial = epot(ni) / ekin(ni)
        virnet = (epot(ni) - eint(ni)) / ekin(ni)
      else
        virial = 0d0
        virnet = 0d0
      endif
      write (luw,570) eeff(ni), eint(ni), eadd(ni), enet
      write (luw,571) epot(ni), ekin(ni), virial
      write (luw,572) epot(ni)-eint(ni), virnet
      write (luw,573) emp, emp+ensr, ensr, eesr, eex, epl
      return
c
c.....Formats:
c
 500  format (/1x,'*** SCF results:')
 510  format (/1x, a78/ 1x, a6, 5x, 'Atomic number=', f12.6)
 520  format (/1x, 'Open shell energy formula: ', a)
 521  format (1x, a1, '(', i4,',',i4,',',i2, ')= ', 1pe15.8)
 522  format (1x, a1, '(', i4,',',i4,',',i2, ')= ', 2pe15.8)
 525  format (/1x, a, ' functions are used as primitive basis.')
 530  format (/1x, 'Symmetry (irrep)', i3,1x,a6)
 535  format (1x, 'El. population ', 8f12.5)
 540  format (1x, 'BASIS / ORB.E. ', 8f12.5)
 550  format (1x, 8f12.8)
 560  format (/1x, 'SCF Convergence :', e15.8,
     & 5x, 'SCF Iterations :', i5)
 570  format (/
     & 1x, 'Eeffective..= ', 1pe21.14 /
     & 1x, 'Einteraction= ', 1pe21.14 /
     & 1x, 'Eadditive...= ', 1pe21.14 /
     & 1x, 'Enet........= ', 1pe21.14  )
 571  format (1x, 'Total potential E= ', 1pe21.14, 3x,
     &  'Kinetic= ', e21.14, 3x, 'Virial= ', e21.14)
 572  format (1x, 'Net potential   E= ', 1pe21.14,
     &  34x, 'Virial= ', e21.14)
 573  format (/1x, 'Electronic interaction energy components:' /
     & 1x, 'Eemp= ', 1pe21.14 /
     & 1x, 'Ecl=  ', 1pe21.14 /
     & 1x, 'Ensr= ', 1pe21.14 /
     & 1x, 'Eesr= ', 1pe21.14 /
     & 1x, 'Eex=  ', 1pe21.14 /
     & 1x, 'Epl=  ', 1pe21.14  )
 600  format (/1x, 'Contributions to the orbital energies:'/ 1x,
     & '------orb----kinetic--------Nuc.At.--------2e-rep.----',
     & '------vmp------------vnsr-----------vesr-----------vex--',
     & '----------pla------')
 610  format (1x, i3, a, 1p 8e15.7)
      end
