c
c-----------------------------------------------------------------------
c
      subroutine setvars (line, lp, luw, nimpre)
c
c.....setvars - interprets settings of program variables.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'celatm.inc'
      include           'corr.inc'
      include           'consts.inc'
      include           'converge.inc'
      include           'error.inc'
      include           'impurity.inc'
      include           'lint.inc'
      include           'scf.inc'
      include           'strtools.inc'
      include           'types.inc'
      include           'vef.inc'
c
      character*(*)     line
      integer           lp, luw, nimpre
c
      character*(ilen)  variable, uppcase, cdum
      logical           ok, setword, setint, setdble, setlogic
c
      if (.not. setword (cdum, line, lp)) then
         call error ('setvars', 'missing variable name', warning)
         return
      endif
      variable = uppcase (cdum)
      lv = leng(variable)
c
c.....is variable a modifiable one?
c
      if (variable(1:lv) .eq. 'EPSFRAC') then
         ok = setdble (epsfrac, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'EPSFRAC', epsfrac
c
      else if (variable(1:lv) .eq. 'EPSDIS') then
         ok = setdble (epsdis, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'EPSDIS', epsdis
c
      else if (variable(1:lv) .eq. 'MXXTRP') then
         ok = setint (mxxtrp, line, lp)
         if (nimpre .ge. 0) write (luw,500) 'MXXTRP', mxxtrp
c
      else if (variable(1:lv) .eq. 'BIAS') then
         ok = setdble (bias, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'BIAS', bias
c
      else if (variable(1:lv) .eq. 'NXTRP') then
         ok = setint (nxtrp, line, lp)
         if (nimpre .ge. 0) write (luw,500) 'NXTRP', nxtrp
c
      else if (variable(1:lv) .eq. 'SCFDIV') then
         ok = setdble (scfdiv, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'SCFDIV', scfdiv
c
      else if (variable(1:lv) .eq. 'THREM') then
         ok = setdble (threm, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'THREM', threm
c
      else if (variable(1:lv) .eq. 'DAMP') then
         ok = setdble (damp, line, lp)
         if (ok) then
            if (damp.gt.zero .and. damp.le.one) then
               if (nimpre .ge. 0) write (luw,510) 'DAMP', damp
               dodamp = .true.
            else if (damp.eq.zero) then
               if (nimpre .ge. 0) write (luw,510) 'DAMP', damp
               dodamp = .false.
            else
               ok = .false.
            endif
         endif
c
      else if (variable(1:lv) .eq. 'CON1') then
         if (setint (natm, line, lp)) then
            ok = (natm.gt.0) .and. (natm.le.mnatom)
            ok = ok .and. setdble (con1(natm), line, lp)
            if (nimpre .ge. 0) write (luw,530) 'CON1', natm, con1(natm)
         else
            ok = setdble (contmp, line, lp)
            if (ok) then
               do i = 0, mnatom
                  con1(i) = contmp
               enddo
               if (nimpre .ge. 0) write (luw,550) 'CON1', contmp
            endif
         endif
c
      else if (variable(1:lv) .eq. 'CON2') then
         if (setint (natm, line, lp)) then
            ok = (natm.gt.0) .and. (natm.le.mnatom)
            ok = ok .and. setdble (con2(natm), line, lp)
            if (nimpre .ge. 0) write (luw,530) 'CON2', natm, con2(natm)
         else
            ok = setdble (contmp, line, lp)
            if (ok) then
               do i = 0, mnatom
                  con2(i) = contmp
               enddo
               if (nimpre .ge. 0) write (luw,550) 'CON2', contmp
            endif
         endif
c
      else if (variable(1:lv) .eq. 'RLASTSHELL') then
         ok = setdble (rlastshell, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'RLASTSHELL', rlastshell
c
      else if (variable(1:lv) .eq. 'PICONV') then
         ok = setdble (piconv, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'PICONV', piconv
c
      else if (variable(1:lv) .eq. 'EWCONV') then
         ok = setdble (ewconv, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'EWCONV', ewconv
c
      else if (variable(1:lv) .eq. 'CONVINT') then
         ok = setdble (convnsr, line, lp)
         convnl = convnsr
         convesr = convnsr
         convxp = convnsr
         if (nimpre .ge. 0) then
            write (luw,510) 'CONVINT', convnsr
            write (luw,510) 'CONVNSR', convnsr
            write (luw,510) 'CONVNL', convnl
            write (luw,510) 'CONVESR', convesr
            write (luw,510) 'CONVXP', convxp
         endif
c
      else if (variable(1:lv) .eq. 'CONVNSR') then
         ok = setdble (convnsr, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'CONVNSR', convnsr
c
      else if (variable(1:lv) .eq. 'CONVNL') then
         ok = setdble (convnl, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'CONVNL', convnl
c
      else if (variable(1:lv) .eq. 'CONVESR') then
         ok = setdble (convesr, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'CONVESR', convesr
c
      else if (variable(1:lv) .eq. 'CONVXP') then
         ok = setdble (convxp, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'CONVXP', convxp
c
      else if (variable(1:lv) .eq. 'MAXPICYCLES') then
         ok = setint (maxpicycles, line, lp)
         maxpicycles = min (maxpicycles, mcycles)
         if (nimpre .ge. 0) write (luw,500) 'MAXPICYCLES', maxpicycles
c
      else if (variable(1:lv) .eq. 'PIDIV') then
         ok = setdble (pidiv, line, lp)
         if (nimpre .ge. 0) write (luw,510) 'PIDIV', pidiv
c
c     else if (variable(1:lv) .eq. 'CORREL') then
c         ok = setword (cdum, line, lp)
c         variable = uppcase (cdum)
c         lv = leng(variable)
c         if (variable(1:lv) .eq. 'HF') then
c            typcorr = typHF
c         else if (variable(1:lv) .eq. 'UCHF') then
c            typcorr = typuCHF
c         else if (variable(1:lv) .eq. 'RCHF') then
c            typcorr = typrCHF
c         else if (variable(1:lv) .eq. 'WIGNER') then
c            typcorr = typWig
c         else if (variable(1:lv) .eq. 'GOMBAS') then
c            typcorr = typGom
c         else if (variable(1:lv) .eq. 'LYP') then
c            typcorr = typLYP
c         else if (variable(1:lv) .eq. 'BR') then
c            typcorr = typBR
c         else
c            ok = .false.
c         endif
c         if (ok .and. nimpre .ge. 0)
c     &      write (luw,540) 'CORREL', variable(1:lv)
c
      else if (variable(1:lv) .eq. 'PROJ') then
         ok = setword (cdum, line, lp)
         variable = uppcase (cdum)
         lv = leng(variable)
         if (variable(1:lv) .eq. 'TMSRH') then
            typpla = tmsrH
         else if (variable(1:lv) .eq. 'TOTHC') then
            typpla = totHC
         else if (variable(1:lv) .eq. 'GRPHC') then
            typpla = grpHC
         else if (variable(1:lv) .eq. 'ABSHC') then
            typpla = absHC
         else if (variable(1:lv) .eq. 'NOPROJ') then
            typpla = noproj
         else
            ok = .false.
         endif
         if (ok .and. nimpre .ge. 0)
     &      write (luw,540) 'PROJ', variable(1:lv)
c
      else if (variable(1:lv) .eq. 'SYMMETRIZE') then
         ok = setlogic (symmetrize, line, lp)
         if (nimpre .ge. 0) write (luw,520) 'SYMMETRIZE', symmetrize
c
      else
         ok = .false.
      endif
c
c.....catch up errors:
c
      if (.not.ok) then
          cdum = 'error setting program variable'//newline//line
          call error ('setvars', cdum, warning)
      endif
      return
 500  format (/1x, '*** New value for variable ', a, ': ', (6i6))
 510  format (/1x, '*** New value for variable ', a, ': ', 1p,
     &    (3e15.7/), (1x,6e15.7))
 520  format (/1x, '*** New value for variable ', a, ': ', (6l6))
 530  format (/1x, '*** New value for variable ', a, '(', i3, '):',
     & 1pe15.7)
 540  format (/1x, '*** New value for variable ', a, ': ', a)
 550  format (/1x, '*** New default value for ', a, 1p, e15.7)
c
      end
