c
c-----------------------------------------------------------------------
c
      subroutine shell (lur, luw)
c
c.....shell - reads the commands contained in the input file and does
c     the appropriate calls to the different modules.
c
c.....INPUT Parameter:
c     luc ...... input logical unit.
c     luw ...... output logical unit.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'cont.inc'
      include           'corr.inc'
      include           'files.inc'
      include           'error.inc'
      include           'red.inc'
      include           'stdio.inc'
      include           'strtools.inc'
      include           'types.inc'
      include           'vef.inc'
c
      character*(ilen)  line, word, fileint, fileion, fileulm, filecoef,
     &                  file1, file2, fileenv, word2
      integer           lualloc
      logical           setword, ok, setline, setint, setdble, callhead
      character*(ilen)  uppcase
c
c.....reset prtimer and fill in general matrices:
c
      call prtimer (0,ipid,'gpi',-1)
      call prtimer (1,ipid,'gpi',-1)
      call fillmat ()
c
c.....default active ion, print value & calculation type:
c
      ni = 1
      nimpre = 0
      typcorr = typHF
      typpla = grpHC
      callhead = .true.
c
c.....Read the next order:
c
      do while (setline(lur, line, lp))
         ll = leng(line)
         if (.not. setword (word2, line, lp)) then
            call error ('shell', 'premature end of line', warning)
            return
         endif
         word = uppcase (word2)
         lw = leng (word)
c
c........CASE sentences to interpret word:
c
         if (word(1:1) .eq. '#' .or. word(1:lw) .eq. 'REM') then
            continue
c
         else if (word(1:lw) .eq. 'SET' ) then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            call setvars (line, lp, luw, nimpre)
c
         else if (word(1:lw) .eq. 'ACTIVE') then
            if (.not. setint (ni, line, lp)) call error ('shell',
     &             'active ion number must be an integer', faterr)
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (nimpre.ge.-1) write (luw,500) ni
 500        format (/1x,'*** NEW ACTIVE ION NUMBER : ',i3)
c
         else if (word(1:lw) .eq. 'CELL') then
            ok = setdble (ared, line, lp)
            ok = ok .and. setdble (bred, line, lp)
            ok = ok .and. setdble (cred, line, lp)
            ok = ok .and. setdble (alf, line, lp)
            ok = ok .and. setdble (bet, line, lp)
            ok = ok .and. setdble (gam, line, lp)
            if (.not.ok) call error ('shell', 'incorrect cell', faterr)
c
         else if (word(1:lw) .eq. 'COPY') then
            ok = setword (file1, line, lp)
            ok = ok .and. setword (file2, line, lp)
            if (.not.ok)
     &         call error ('shell', 'missing filename in copy', faterr)
            call copyfile (file1, file2)
c
         else if (word(1:lw) .eq. 'CLUSTER') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            call cluster (lur, luw, nimpre)

         else if (word(1:lw) .eq. 'IMPURITY') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            call impurity (lur, luw, nimpre)

         else if (word(1:lw) .eq. 'CRYSTAL') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            call crystal (lur, luw, nimpre)
c
         else if (word(1:lw) .eq. 'VACUO') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            call vacuo (line, lp, luw, nimpre)
c
         else if (word(1:lw) .eq. 'EDEF') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            call edef (line, lp, luw, nimpre)
c
         else if (word(1:lw) .eq. 'HF') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            typcorr = typHF
            if (nimpre.ge.-1) write (luw,600)
c
         else if (word(1:lw) .eq. 'RCHF') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            typcorr = typrCHF
            if (nimpre.ge.-1) write (luw,602)
c
         else if (word(1:lw) .eq. 'UCHF') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            typcorr = typuCHF
            if (nimpre.ge.-1) write (luw,601)
c
         else if (word(1:lw) .eq. 'INT>') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (.not.setword (fileint, line, lp)) call error ('shell',
     &         'missing integrals filename',faterr)
            if (typcorr .eq. typHF) then
               fint(ni) = fileint
            else
               fcint(ni) = fileint
            endif
            call istupq (fileint, ni, typcorr, wrint, luw, nimpre)
c
         else if (word(1:lw) .eq. 'INT<') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (.not.setword (fileint, line, lp)) call error ('shell',
     &         'missing integrals filename',faterr)
            if (typcorr .eq. typHF) then
               fint(ni) = fileint
            else
               fcint(ni) = fileint
            endif
            call istupq (fileint, ni, typcorr, rdint, luw, nimpre)
c
         else if (word(1:lw) .eq. 'UINT') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (.not.setword (fint(ni), line, lp)) call error ('shell',
     &         'missing integrals filename',faterr)
            if (.not.setword (fcint(ni), line, lp)) call error ('shell',
     &         'missing integrals filename',faterr)
            call istupq (fint(ni), ni, typHF, wrint, luw, nimpre)
            call istupq (fcint(ni), ni, typuCHF, wrint, luw, nimpre)
c
         else if (word(1:lw) .eq. 'ION#') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (.not. setint (ni, line, lp)) call error ('shell',
     &             'ion number must be an integer', faterr)
            if (.not.setword (fileion, line, lp)) call error ('shell',
     &         'missing ionic filename',faterr)
            if (.not.setword (fileulm, line, lp)) call error ('shell',
     &         'missing ulm filename',faterr)
            if (.not.setword (filecoef, line, lp)) call error ('shell',
     &         'missing coef filename',faterr)
            call readion (fileion, ni, nimpre, luw)
            call readulm (fileulm, ni, nimpre, luw)
            call readcoef (filecoef, ni, nimpre, luw)
c
         else if (word(1:lw) .eq. 'LAT<') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (.not.setword (fileint, line, lp)) call error ('shell',
     &         'missing integrals filename',faterr)
            call intred (fileint, ni, rdint, luw, nimpre)
c
         else if (word(1:lw) .eq. 'SCF>') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (.not.setword (filecoef, line, lp)) call error ('shell',
     &         'missing ionic filename',faterr)
            call scfat (ni, luw, nimpre)
            if (typcorr .eq. typuCHF) call uchf (ni, wrint, luw, nimpre)
            if (nimpre .ge. -2) call writecoef (filecoef, ni)
c
         else if (word(1:lw).eq.'MP>')  then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (.not.setword (fileion, line, lp)) call error ('shell',
     &         'missing ionic filename',faterr)
            call vefion (fileion, ni, wrint, luw, nimpre)
c
         else if (word(1:lw).eq.'VEF')  then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (.not.setword (fileion, line, lp)) call error ('shell',
     &         'missing ionic filename',faterr)
            if (.not.setword (fileulm, line, lp)) call error ('shell',
     &         'missing ulm filename',faterr)
            if (.not.setword (filecoef, line, lp)) call error ('shell',
     &         'missing coef filename',faterr)
            call readion (fileion, ni, nimpre, luw)
            call readulm (fileulm, ni, nimpre, luw) 
            call readcoef (filecoef, ni, nimpre, luw)
            call istupq ('dummy', ni, typcorr, nwint, luw, nimpre)
            call densi (ni)
            call vefion (fileion, ni, nwint, luw, nimpre)
            call vefion (fileion, ni, wrint, luw, nimpre)
c
         else if (word(1:lw) .eq. 'HELP') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            call help (luw)
c
         else if (word(1:lw) .eq. 'OUT')  then
            if (setword (file1, line, lp)) then
               if (luw .ne. stdout) then
                  close (luw)
                  call lunalloc (luw)
               endif
            else
               call error ('shell', 'missing output filename', warning)
            endif
            luw = lualloc (luw)
            luwrite = luw
            lf = leng (file1)
            open (luw, file=file1(1:lf), status='unknown', iostat=nios)
            if (nios .ne. 0) then
               luw = stdout
               luwrite = luw
               call error ('shell', 'Error while opening'//
     &              file1(1:lf), warning)
            endif
c
         else if (word(1:lw) .eq. 'PRINT') then
            if (.not. setint (nimpre, line, lp)) call error ('shell',
     &             'Print value must be an integer', warning)
            if (callhead) callhead = nimpre .ge. -1
c
         else if (word(1:lw) .eq. 'TITLE') then
            tition(ni) = line(lp:ll)
c
         else if (word(1:lw) .eq. 'SHOW') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            call showvars (luw)
c
         else if (word(1:lw) .eq. 'END') then
            if (callhead) then
               call header (luw)
               call dater (-1, luw)
               callhead = .false.
            endif
            if (nimpre.ge.-1) then
               call prtimer (5,ipid,'gpi',luw)
               call dater (1, luw)
            endif
            return
c
         else
            call error ('shell', 'order not found'//newline//line(1:ll),
     &                  warning)
            if (nimpre.ge.-2) then
               call prtimer (5,ipid,'gpi',luw)
               call dater (1, luw)
            endif
            return
         endif
      enddo
c
c.....no next order
c
      if (nimpre.ge.-2) call prtimer (5,ipid,'gpi',luw)
      return
c
 600  format (/
     & 1x,'HHH   HHH   FFFFFFFFF'/
     & 1x,'HHH   HHH   FFF      '/
     & 1x,'HHH   HHH   FFFFFF   '/
     & 1x,'HHHHHHHHH   FFF         HF calculation requested'/
     & 1x,'HHH   HHH   FFF      '/
     & 1x,'HHH   HHH   FFF      '/
     & /)
 601  format (/
     & 1x,'          CCCCCC  HHH   HHH  FFFFFFFFF'/
     & 1x,'         CCC      HHH   HHH  FFF      '/
     & 1x,'uu   uu  CCC      HHH   HHH  FFFFFF   '/
     & 1x,'uu   uu  CCC      HHHHHHHHH  FFF         uCHF calculation'/
     & 1x,'uu   uu  CCC      HHH   HHH  FFF         requested'/
     & 1x,' uuuu     CCCCCC  HHH   HHH  FFF      '/
     & /)
 602  format (/
     & 1x,'          CCCCCC  HHH   HHH  FFFFFFFFF'/
     & 1x,'r rrrr   CCC      HHH   HHH  FFF      '/
     & 1x,'rrrrrrr  CCC      HHH   HHH  FFFFFF   '/
     & 1x,'rr   rr  CCC      HHHHHHHHH  FFF         rCHF calculation'/
     & 1x,'rr       CCC      HHH   HHH  FFF         requested'/
     & 1x,'rr        CCCCCC  HHH   HHH  FFF      '/
     & /)
      end
