c
c-----------------------------------------------------------------------
c
      subroutine showvars (luw)
c
c.....showvars - print actual setting for tunable variables and
c     global parameters of the program.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'celatm.inc'
      include           'consts.inc'
      include           'converge.inc'
      include           'corr.inc'
      include           'impurity.inc'
      include           'lint.inc'
      include           'scf.inc'
      include           'types.inc'
      include           'vef.inc'
c
      write (luw,500)
      write (luw,510) mnt, msa, maos, msto, mstosym, mdens, maxpq, mred,
     &                mnbuff, mpot, namax, mcycles, mcel, mpure, mimp
      write (luw,520) epsfrac, epsdis
      write (luw,530) mxxtrp, bias, nxtrp, scfdiv, threm
      write (luw,540)
      write (luw,550) (i, con1(i), con2(i), i = 0, mnatom)
      if (dodamp) then
         write (luw,560) rlastshell, piconv, ewconv, convnsr, convnl,
     &                   convesr, convxp, maxpicycles, pidiv, damp
      else
         write (luw,560) rlastshell, piconv, ewconv, convnsr, convnl,
     &                   convesr, convxp, maxpicycles, pidiv, zero
      endif
      if (typcorr .eq. typHF) then
         write (luw,570) 'HF (none)'
      else if (typcorr .eq. typuCHF) then
         write (luw,570) 'uCHF'
      else if (typcorr .eq. typrCHF) then
         write (luw,570) 'rCHF'
c      else if (typcorr .eq. typWig) then
c         write (luw,570) 'Wigner'
c      else if (typcorr .eq. typGom) then
c         write (luw,570) 'Gombas'
c      else if (typcorr .eq. typLYP) then
c         write (luw,570) 'LYP (Lee-Yang-Parr)'
c      else if (typcorr .eq. typBR) then
c         write (luw,570) 'BR (Brual-Rothstein)'
      endif
      if (typpla .eq. tmsrH) then
         write (luw,580) 'Huzinaga TMSR'
      else if (typpla .eq. totHC) then
         write (luw,580) 'Hojer-Chung (<F>)'
      else if (typpla .eq. grpHC) then
         write (luw,580) 'Hojer-Chung (<F^R>)'
      else if (typpla .eq. absHC) then
         write (luw,580) 'Hojer-Chung (|<F^R>|)'
      else if (typpla .eq. noproj) then
         write (luw,580) 'No projection'
      endif
      write (luw,600) symmetrize
      return
c
 500  format (/'1'/
     & 1x, '*** DEFAULT PARAMETER AND VARIABLE SETTINGS :'/
     & 1x, '*** Parameters must be changed in the source code.'/
     & 1x, '*** Variables may be changed at run time with SET orders'/)
 510  format (1x, '*** GLOBAL PARAMETERS :'/
     & 1x, 'Max ionic types                (MNT): ', i6/
     & 1x, 'Max symmetries per atom        (MSA): ', i6/
     & 1x, 'Max AOs per atom              (MAOS): ', i6/
     & 1x, 'Max STOs per atom             (MSTO): ', i6/
     & 1x, 'Max STOs per symmetry      (MSTOSYM): ', i6/
     & 1x, 'Max densities per atom       (MDENS): ', i6/
     & 1x, 'Max P & Q integrals          (MAXPQ): ', i6/
     & 1x, 'Max environment ions          (MRED): ', i6/
     & 1x, 'Max buffer of env. ions     (MNBUFF): ', i6/
     & 1x, 'Max piip potential shells     (MPOT): ', i6/
     & 1x, 'Max n quantum number         (NAMAX): ', i6/
     & 1x, 'Max PI cycles              (MCYCLES): ', i6/
     & 1x, 'Max ions in cell - crys       (MCEL): ', i6/
     & 1x, 'Max ions in cell - imp       (MPURE): ', i6/
     & 1x, 'Max cluster ions - clus & imp (MIMP): ', i6/ )
 520  format (1x, '*** TOLERANCES ON POSITIONS OF IONS :'/
     & 1x, 'Fractional coordinates     (EPSFRAC): ', 1pe13.6/
     & 1x, 'Distances                   (EPSDIS): ', 1pe13.6/ )
 530  format (1x, '*** VARIABLES CONTROLLING SCF CONVERGENCE :'/
     & 1x, 'Max SCF iterations          (MXXTRP): ', i6/
     & 1x, 'Initial convergence bias      (BIAS): ', 1pe13.6/
     & 1x, 'Duplicate threshold each     (NXTRP): ', i6/
     & 1x, 'Divergence threshold        (SCFDIV): ', 1pe13.6/
     & 1x, 'Convergence scale            (THREM): ', 1pe13.6/)
 540  format (1x, '*** COULOMB HOLE VARIABLES : ',
     & 'Cut off (CON1) & (CON2) values      : '/
     & 1x, '--Z------con1------------con2-----     ',
     & 1x, '--Z------con1------------con2-----     ',
     & 1x, '--Z------con1------------con2-----')
 550  format ( 3(1x,i4,1p,2e15.8,0p,5x) )
 560  format (1x, '*** PI CONVERGENCE VARIABLES :'/
     & 1x, 'Max interaction distance        (RLASTSHELL): ', 1pe15.8/
     & 1x, 'PI convergence on the Energy        (PICONV): ', 1pe15.8/
     & 1x, 'Ewald convergence on the Energy     (EWCONV): ', 1pe15.8/
     & 1x, 'Nuclear short range convergence    (CONVNSR): ', 1pe15.8/
     & 1x, 'Nucleus-lattice convergence         (CONVNL): ', 1pe15.8/
     & 1x, 'Coulomb short range convergence    (CONVESR): ', 1pe15.8/
     & 1x, 'Exchange & Projection convergence   (CONVXP): ', 1pe15.8/
     & 1x, 'Max PI cycles                  (MAXPICYCLES): ', i6/
     & 1x, 'PI divergence on Energy threshold    (PIDIV): ', 1pe15.8/
     & 1x, 'PI cycles damping factor              (DAMP): ', 1pe15.8/)
 570  format (1x, '*** CORRELATION ENERGY VARIABLES :'/
     & 1x, 'Type of correlation included        (CORREL): ', a/)
 580  format (1x, '*** PROJECTION OPERATOR VARIABLES :'/
     & 1x, 'Type of projection operator used      (PROJ): ', a/)
 600  format (1x, '*** POTENTIAL SYMMETRIZATION VARIABLES :'/
     & 1x, 'Symmetrize imp-lat. interaction (SYMMETRIZE): ', l7/)
c
      end
