c
c-----------------------------------------------------------------------
c
      subroutine ortho (d, l, laue, lcent, ier, id)
c
c.....ortho - set symmetry operations for orthorhombic crystals.
c
      include           'implicit.inc'
      include           'consts.inc'
      dimension         d(3,3),l(4,4)
c
c.....it is orthorhombic
      laue = 3
c
c.....set up counts of the various types of mirrors.
      im = 0
      ir = 0
      ia = 0
      ib = 0
      ic = 0
      id = 0
      i21 = 0
c
c.....do we have a 2-axis along A
      if ( l(1,2).ne.13 ) then
c
         ir = 1
         if ( l(1,2).eq.9 ) im=4
c        if ( l(1,2).eq.4 ) ier =5  return
         if ( l(1,2).eq.3 ) ib=1
         if ( l(1,2).eq.2 ) ic=1
         if ( l(1,2).eq.11 ) id=1
         if ( l(1,3).eq.4.or.l(1,3).eq.10 ) d(1,1)=half
         if ( l(1,4).eq.4.or.l(1,4).eq.10 ) d(1,1)=d(1,1)+half
c
c.....yes is it a 21?
      else if(l(2,2).eq.12) then
         d(1,2) = half
         d(1,3) = half
         i21 = 4
      endif
c
c.....do we have a 2-axis along B
      if ( l(1,3).ne.13 ) then
c
         ir = ir+1
         if ( l(1,3).eq.9 ) im=im+2
         if ( l(1,3).eq.4 ) ia=1
C        if ( l(1,3).eq.3 ) ier =5 return
         if ( l(1,3).eq.2 ) ic=ic+1
         if ( l(1,3).eq.11 ) id=id+1
         if ( l(1,2).eq.3.or.l(1,2).eq.10 ) d(2,2)=half
         if ( l(1,4).eq.3.or.l(1,4).eq.10 ) d(2,2)=d(2,2)+half
c
c.....yes, is it a 21?
      else if (l(2,3).eq.12) then
         d(2,1) = half
         d(2,3) = half
         i21 = i21+2
      endif
c
c.....do we have a 2-axis along C
      if ( l(1,4).ne.13 ) then
         ir = ir+1
         if ( l(1,4).eq.9 ) im=im+1
         if ( l(1,4).eq.4 ) ia=ia+1
         if ( l(1,4).eq.3 ) ib=ib+1
C        if ( l(1,4).eq.2 ) ier=5 return
         if ( l(1,4).eq.11 ) id=id+1
         if ( l(1,2).eq.2.or.l(1,2).eq.10 ) d(3,3)=half
         if ( l(1,3).eq.2.or.l(1,3).eq.10 ) d(3,3)=d(3,3)+half
c
c.....yes , is it a 21
      else if (l(2,4).eq.12) then
         d(3,1) = half
         d(3,2) = half
         i21 = i21+1
      endif
c.....if there are 3 mirrors check for centering
c     which may alter the origin location
c
      if ( ir.eq.3 )  then
c........3 mirrors present.  is the lattice centered?
         if ( lcent.eq.1 ) return
c........yes . is it A-centered?
         if ( lcent.eq.2 ) then
c...........an A-centered lattice.
c           only one B or C glide present.relocate the mirrors by A
            if ( ib+ic.ne.1 ) return
            if ( ia.eq.2 ) return
            d(2,2) = d(2,2)+half
            d(3,3) = d(3,3)+half
            return
         endif
c
c........no.   is it B-centered?
         if ( lcent.eq.3 ) then
c
c...........a B-centered lattice
            if ( ia+ic.ne.1 ) return
            if ( ib.eq.2 ) return
            d(1,1) = d(1,1)+half
            d(3,3) = d(3,3)+half
            return
         endif
c
c........no.  is it C-centered?
         if ( lcent.eq.4 ) then
c
c...........a C-centered lattice
            if ( ia+ib.ne.1 ) return
            if ( ic.eq.2 ) return
            d(1,1) = d(1,1)+half
            d(2,2) = d(2,2)+half
            return
         endif
c
c........no.   is it I-centered?
         if ( lcent.ne.5 ) return
c
c........yes.  if only 1 glide plane shift the mirrors by I
         if ( ia+ib+ic.ne.1 ) return
         d(1,1) = d(1,1)+half
         d(2,2) = d(2,2)+half
         d(3,3) = d(3,3)+half
         return
      endif
c
c.....less than 3 mirrors. set up the 2-axes locations
      if ( i21.eq.4.or.i21.eq.5.or.i21.eq.7 ) d(1,2)=zero
      if ( i21.eq.6.or.i21.eq.7 ) d(1,3)=zero
      if ( i21.eq.3 ) d(2,1)=zero
      if ( i21.eq.2.or.i21.eq.6.or.i21.eq.7 ) d(2,3)=zero
      if ( i21.eq.1.or.i21.eq.3.or.i21.eq.7 ) d(3,1)=zero
      if ( i21.eq.5 ) d(3,2)=zero
      if ( im.le.0 ) return
      if ( im.eq.1.and.(i21.eq.4.or.i21.eq.2)) then
         if ( d(3,3).eq.zero ) return
         d(3,3)=zero
         d(3,2) = d(3,2)+half
         return
      endif
      if ( im.eq.2.and.(i21.eq.4.or.i21.eq.1)) then
         if ( d(2,2).eq.zero ) return
         d(2,2)=zero
         d(2,1) = d(2,1)+half
         return
      endif
      if ( im.eq.4.and.(i21.eq.2.or.i21.eq.1)) then
         if ( d(1,1).eq.zero ) return
         d(1,1)=zero
         d(1,3) = d(1,3)+half
         return
      endif
c     if ( im.eq.3.amd.i21.eq.4 ) ier=5 return
c     if ( im.eq.5.and.i21.eq.2 ) ier=5 return
c     if ( im.eq.6.and.i21.eq.1 ) ier=5 return
      return
      end
