c
c-----------------------------------------------------------------------
c
      subroutine sglatc (k, l, d, lcent, laue, naxis, ier, ncubic, id)
c
c.....sglatc - determine the laue group and unique axis if monoclinic
c
      include           'implicit.inc'
      include           'consts.inc'
      dimension         d(3,3), l(4,4)
c
      if (k.lt.3) then
        if (l(1,2).eq.17) then
c
c.........6/m
c
          laue=11
          return
        else if(l(1,2).eq.14) then
c
c.........2bar
c
          laue=8
          return
        else if(l(1,2).eq.12) then
c
c.........1bar
c
          laue=1
          return
        else if(l(1,2).ne.15) then
c
c.........2/m, B-axis unique
c
          im=2
          laue = 2
          naxis = 2
          ia = 4
          ic = 2
          na = 1
          nb = 2
          nc = 3
          if ( l(2,im).eq.12 ) d(nb,naxis)=half
          if ( l(3,im).eq.ia.or.l(3,im).eq.10 ) d(na,naxis)=half
          if ( l(3,im).eq.ic.or.l(3,im).eq.10 ) d(nc,naxis)=half
          if ( l(4,im).eq.ia.or.l(4,im).eq.10 ) d(na,naxis)=half
          if ( l(4,im).eq.ic.or.l(4,im).eq.10 ) d(nc,naxis)=half
          return
        else
c
c.........4/m
c
          laue=4
c
c.........is there a n-glide normal to c?
c
          if ( lcent.le.3 ) then
            if (l(3,2).eq.10) then
c
c.............P 4N/N * *
c
              d(1,3) = half
              return
            endif
            if (l(4,2).eq.10) d(2,3)=half
            return
c
c.........is it c-centered?
c
          else if (lcent.eq.4) then
c
c...........if there is no A-glide normal to C we are through
c
            if ( l(3,2).ne.4.and.l(4,2).ne.4 ) return
            d(1,3) = fourth
            d(2,3) = fourth
            if ( l(4,2).eq.4 ) d(2,3)=75d-2
            return
c
c.........is it I-centered or F-centered
c
          else if (lcent.ge.5) then
c
c...........is there an A-glide or a D-glide normal to C?
c
            if ( l(4,2).ne.4.and.l(4,2).ne.11 ) then
c
c.............no
c
              call ifcent (l,d,lcent,ier)
              return
            else
c
c.............yes
c
              d(1,3) = 75d-2
              if ( lcent.eq.5 ) d(2,3) = fourth
              return
            endif
          endif
        endif
c
      else if (k .eq. 3) then
c
c.......3 fields.  M3 cubic. (R3R has been taken care of)
c
        if ( l(1,3).ne.14 ) then
          ier=20
          return
        endif
        laue = 13
c
c.......set the B-axis translation flag if A 21 along A
c
        if ( l(2,2).eq.12 ) d(2,1)=half
c
c.......set the C-axis translation flag if an A-glide normal to C
c
        if ( l(1,2).eq.3.or.l(1,2).eq.4 ) d(3,3)=half
        ncubic=1
        return
c
      else if (k .gt. 3) then
c
c.......four fields read.
c
        if ( l(1,3).eq.14 ) then
c
c.........it is m3m cubic
c
          laue = 14
c
c.........set the C-axis translation flag if an A-glide normal to C
c
          if ( l(1,2).eq.3.or.l(1,2).eq.4 ) d(3,3)=half
c
c.........is a 4N-axis specified?
c
          if ( l(1,2).ne.15 ) then
            ncubic=1
            return
          endif
c
c.........yes.  is it 4bar?
c
          if ( l(2,2).eq.3 ) then
c
c...........4B.  is it 4B 3 M?
c
            if ( l(1,4).eq.9 )  then
              ncubic=1
              return
            endif
c
c...........no.  is it 4B 3 D?
c
            if ( l(1,4).eq.11 ) then
c
c.............I 4B 3 D we hope
c
              if ( lcent.ne.5 ) then
                ier=21
                return
              endif
              d(1,3) = 75d-2
              d(2,3) = fourth
              d(3,3) = 75d-2
              ncubic=1
              return
            endif
c
c...........no.
c
            d(1,3) = half
            d(2,3) = half
            d(3,3) = half
            ncubic=1
            return
          endif
c
c.........no.  is it a 4?
c
          if ( l(2,2).lt.12 .or. l(2,2).gt.14 ) then
            ncubic=1
            return
          endif
c
c.........no. is it a 41?
c
          if ( l(2,2).eq.12 ) then
c
c...........41-axis. is it F 41 3 2?
c
            if ( lcent.eq.6 ) then
c
c.............F 41 3 2
c
              d(1,3) = fourth
              d(2,3) = fourth
              ncubic=1
              return
            endif
c
c...........no. it is either P 41 3 2 or I 41 3 2
c
            d(1,3) = fourth
            d(2,3) = -fourth
            ncubic=1
            return
          endif
c
c.........no . is it a 42?
c
          if ( l(2,2).eq.13 ) then
c
c...........P 42 3 2
c
            d(1,3) = half
            d(2,3) = half
            ncubic=1
            return
          endif
c
c.........no.  it must be a 43
c
c.........P 43 3 2
c
          if ( lcent.eq.6 ) then
c
c...........F 41 3 2
c
            d(1,3) = fourth
            d(2,3) = fourth
            ncubic=1
            return
          endif
          d(1,3) = 75d-2
          d(2,3) = fourth
          ncubic=1
          return
        else if (l(1,2).eq.17) then
          if ( l(1,3).eq.12 ) then
c
c...........we have something like P 6N 1 *
c
            if ( l(1,4).ne.12 ) then
c
c.............it is hexagonal 6/mmm
c
              laue = 12
              return
            endif
c
c...........6/M
c
            laue = 11
            return
          endif
c
c.........it is hexagonal 6/mmm
c
          laue = 12
          return
c
        else if (l(1,2).eq.14) then
c
c.........it is trigonal P3**
c
          if ( l(1,3).eq.12 ) then
c
c...........it is trigonal 31*
c
            if ( l(1,4).eq.12 ) then
c
c.............3BAR
c
              laue = 8
              return
            endif
c
c...........it is trigonal 31M
c
            laue = 10
            return
          endif
          if ( l(1,4).ne.12 ) then
c
c...........it is hexagonal 6/mmm
c
            laue = 12
            return
          endif
c
c.........it is trigonal 3M1
c
          laue = 9
          return
        else if (l(1,2).eq.15) then
c
c.........it is tetragonal 4/mmm
c
          laue = 5
c
c.........if there is an N-glide normal to C place any
c         mirror normal to A at 1/4
c
          if ( l(3,2).eq.10.or.l(4,2).eq.10 ) d(1,1)=half
c
c.........if there is an A-glide normal to C place any
c         mirror normal to (110) at 1/4
c
          if ( l(3,2).eq.4.or.l(4,2).eq.4 ) d(2,2)=fourth
c
c.........if there is a 21 along B move place it at X=1/4
c
          if ( l(1,3).eq.13.and.l(2,3).eq.12 ) d(1,2)=half
c
c.........if there is a 21 along (110) move place it at X=1/4
c
          if ( l(1,4).eq.13.and.l(2,4).eq.12 ) d(2,1)=half
c
c.........if there is either a B- or N-glide normal to the A-axis
c         shift the mirror by 1/4 along the A-axis
c
          if ( l(1,3).eq.3.or.l(1,3).eq.10 ) d(1,1)=d(1,1)+half
c
c.........if there is either a B- OR N-glide normal to (110)
c         shift the mirror by 1/4 along the A-axis
c
          if ( l(1,4).eq.3.or.l(1,4).eq.10 ) d(2,2)=d(2,2)+fourth
c
c.........set the Z location for 2-axes along (110)
c
          if ( l(2,2).gt.11.and.l(2,2).lt.15.and.l(2,3).ne.12 )
     &      d(3,1)=-(l(2,2)-11)/four
c
c.........set the Z-translation for 21-axes along (110)
c
          if ( (l(1,4).ne.13.or.l(2,4).eq.12) .and.
     &         l(2,2).gt.11.and.l(2,2).lt.15 ) d(3,1)=(l(2,2)-11)/four
c
c.........set the Z-translation for 21-axes along B
c
          if ( (l(1,3).ne.13.or.l(2,3).eq.12) .and.
     &         l(2,2).gt.11.and.l(2,2).lt.15 ) d(3,2)=(l(2,2)-11)/four
c
c.........place the D in F 4* D * at Y=7/8
c
          if ( l(1,3)+l(3,2).eq.11.and.lcent.eq.6 ) d(2,1)=75d-2
c
c.........M in F 4** * * at X=1/8 if there is a C along (110)
c
          if ( l(1,4).eq.2.and.lcent.eq.6 ) d(1,1)=half
c
c.........is this a 4bar?
c
          if ( l(2,2).eq.3 ) then
c
c...........translations due to diagonal symmetry operation
c
            if ( l(1,3).eq.11.and.lcent.eq.6 ) d(3,1)=fourth
c
c...........if * 4B * 21 we want the mirror at X=1/4
c
            if ( l(1,4).eq.13.and.l(2,4).eq.12 ) d(1,1)=half
c
c...........C- or a N-glide along (110) set the 2-axis at Z=1/4
c
            if ( l(1,4).eq.2.or.l(1,4).eq.10 ) d(3,2)=half
c
c...........a B- or a N-glide along (110) set the 2 at X=1/4
c
            if ( l(1,4).eq.3.or.l(1,4).eq.10 ) d(1,2)=half
            if ( l(1,4).ne.11 ) return
            if ( lcent.eq.5 ) d(1,2) = half
            d(3,2) = 75d-2
            return
          endif
c
c.........is the lattice primitive?
c
          if ( lcent.gt.1 ) then
            call ifcent  (l,d,lcent,ier)
            return
          endif
c
c.........yes.  do we have a N-glide normal to C?
c
          if ( l(3,2).eq.10.or.l(4,2).eq.10 ) then
c
c...........P 4N/N * *
c
            d(1,3) = half
            return
          endif
c
c.........no.  do we have a 21 along B?
c
          if ( l(1,3).eq.13.and.l(2,3).eq.12 ) then
            d(1,3) = half
            d(2,3) = half
            return
          endif
c
c.........no. do we have a N-glide normal to A?
c
          if ( l(1,3).ne.10 ) return
          if ( l(2,2).le.0 )  return
          if ( l(2,2).gt.15)  return
          d(1,3) = half
          d(2,3) = half
          return
        else if (l(1,2).eq.12) then
          if ( l(1,3).eq.12 ) then
            if ( l(1,4).eq.12 ) then
c
c.............1BAR
c
              laue = 1
              return
            endif
c
c...........it is C-axis unique monoclinic
c
            laue = 2
            naxis = 3
            ia = 4
            ic = 3
            na = 1
            nb = 3
            nc = 2
            im = 4
          else
c
c...........it is not C-axis unique monoclinic
c
            if ( l(1,4).ne.12 ) then
              call ortho (d, l, laue, lcent, ier, id)
              return
            endif
            im = 3
c
c...........it is B-axis unique monoclinic. (FULL SYMBOL USED)
c
            laue = 2
            naxis = 2
            ia = 4
            ic = 2
            na = 1
            nb = 2
            nc = 3
          endif
          if ( l(2,im).eq.12 ) d(nb,naxis)=half
          if ( l(3,im).eq.ia.or.l(3,im).eq.10 ) d(na,naxis)=half
          if ( l(3,im).eq.ic.or.l(3,im).eq.10 ) d(nc,naxis)=half
          if ( l(4,im).eq.ia.or.l(4,im).eq.10 ) d(na,naxis)=half
          if ( l(4,im).eq.ic.or.l(4,im).eq.10 ) d(nc,naxis)=half
          return
        else if (l(1,3).eq.12) then
          if ( l(1,4).ne.12 ) then
            call ortho (d, l, laue, lcent, ier, id)
            return
          endif
c
c.........it is A-axis unique monoclinic
c
          laue = 2
          naxis = 1
          ia = 3
          ic = 2
          na = 2
          nb = 1
          nc = 3
          im = 2
          if ( l(2,im).eq.12 ) d(nb,naxis)=half
          if ( l(3,im).eq.ia.or.l(3,im).eq.10 ) d(na,naxis)=half
          if ( l(3,im).eq.ic.or.l(3,im).eq.10 ) d(nc,naxis)=half
          if ( l(4,im).eq.ia.or.l(4,im).eq.10 ) d(na,naxis)=half
          if ( l(4,im).eq.ic.or.l(4,im).eq.10 ) d(nc,naxis)=half
          return
        else
c
c.........It may be orthorhombic
c
          call ortho (d, l, laue, lcent, ier, id)
          return
        endif
      endif
c
      return
      end
