c
c-----------------------------------------------------------------------
c
      subroutine        sgprnt (spg, lpt)
c
c.....sgprnt - prints out spatial symmetry information.
c
      include           'implicit.inc'
      include           'consts.inc'
      include           'spgcom.inc'
c
      character*(*)     spg
      integer           lpt
c
      parameter         (sixth       = one/6d0)
      parameter         (twothird    = two/three)
      parameter         (fivesixth   = 5d0*sixth)
c
      character*(1)     nax(3)
      character*(3)     outl(3,2,24)
      character*(3)     xyz(12), polar(8), tra(11)
      character*(8)     chlaue(14)
      character*(12)    ltyp(7), syst(8)
c
      dimension         ncvt(7),cenv(3,6)
      dimension         nsys(14)
      dimension         tra2(11)
c
c.....datas
c
      data
     & tra2( 1),tra2( 2),tra2( 3) /zero   ,zero  ,sixth/,
     & tra2( 4),tra2( 5),tra2( 6) /fourth ,third ,zero/,
     & tra2( 7),tra2( 8),tra2( 9) /half   ,zero  ,twothird/,
     & tra2(10),tra2(11)          /75d-2  ,fivesixth/
c
      data ltyp /   'primitive   ', 'A-centered  ', 'B-centered  ',
     &              'C-centered  ', 'I-centered  ', 'F-centered  ',
     &              'R-centered  ' /
      data syst /   'triclinic   ', 'monoclinic  ', 'orthorhombic',
     &              'tetragonal  ', 'trigonal-R  ', 'trigonal-P  ',
     &              'hexagonal   ', 'cubic       ' /
c
      data chlaue / '1bar    ', '2/m     ', 'mmm     ', '4/m     ',
     &              '4/mmm   ', '3bar    ', '3barm   ', '3bar    ',
     &              '3barm1  ', '3bar1m  ', '6/m     ', '6/mmm   ',
     &              'm3      ', 'm3m     ' /
c
      data polar  / 'x  ',   'y  ',   'x y',   'z  ',   'x z',
     &              'y z',   'xyz',   '111' /
c
      data nax    / 'a',      'b',      'c' /
c
      data xyz   /  '-z ',   '-y ',   '-x ',   'x-y',   'err',
     &              'y-x',   ' x ',   ' y ',   ' z ',   '+x ',
     &              '+y ',   '+z ' /
c
      data tra   /  '   ',   'err',   '1/6',   '1/4',   '1/3',
     &              'err',   '1/2',   'err',   '2/3',   '3/4',
     &              '5/6' /
c
      data
     & nsys( 1),nsys( 2),nsys( 3),nsys( 4),nsys( 5) /1,2,3,4,4/,
     & nsys( 6),nsys( 7),nsys( 8),nsys( 9),nsys(10) /5,5,6,6,6/,
     & nsys(11),nsys(12),nsys(13),nsys(14)          /7,7,8,8/
c
      data
     & ncvt(1),ncvt(2),ncvt(3),ncvt(4),ncvt(5) /1,2,2,2,2/,
     & ncvt(6),ncvt(7)                         /4,3/
c
      data
     & cenv(1,1),cenv(2,1),cenv(3,1) /zero     ,half     ,half     /,
     & cenv(1,2),cenv(2,2),cenv(3,2) /half     ,zero     ,half     /,
     & cenv(1,3),cenv(2,3),cenv(3,3) /half     ,half     ,zero     /,
     & cenv(1,4),cenv(2,4),cenv(3,4) /half     ,half     ,half     /,
     & cenv(1,5),cenv(2,5),cenv(3,5) /third    ,twothird ,twothird /,
     & cenv(1,6),cenv(2,6),cenv(3,6) /twothird ,third    ,third    /
c
      ncv = ncvt(lcent)
      multgen = ncv*neqv*(ncent+1)
      lsys = nsys(laue)
      cen(1,1) = zero
      cen(2,1) = zero
      cen(3,1) = zero
      if ( ncv.gt.1 )  then
         j = lcent-1
         if ( lcent.eq.6 ) j=1
         if ( lcent.eq.7 ) j=5
         do 100 i=2,ncv
            cen(1,i) = cenv(1,j)
            cen(2,i) = cenv(2,j)
            cen(3,i) = cenv(3,j)
            j = j+1
100      continue
      endif
      npx = 1
      npy = 2
      npz = 4
      npxyz = 0
      npyxz = 1
      do 120 i=1,neqv
         if ( jrt(1,1,i).le.0 ) npx=0
         if ( jrt(2,2,i).le.0 ) npy=0
         if ( jrt(3,3,i).le.0 ) npz=0
         if ( jrt(1,3,i).gt.0 ) npxyz=8
         if ( jrt(1,3,i).lt.0 ) npyxz=0
120   continue
      npol = (npx+npy+npz+npxyz*npyxz)*(1-ncent)
      naxi = naxis
      if (lsys.eq.4.or.lsys.eq.6.or.lsys.eq.7) naxi=3
      neqv2 = neqv + 2
c
c.....Create rotm matrix
c
      do 211 i=1,neqv
         do 212 j=1,3
            do 213 k=1,3
               rotm(j,k,i)=jrt(j,k,i)
 213        continue
            rotm(j,4,i)=tra2(jrt(j,4,i)+1)
 212     continue
 211  continue
c
c.....Write the results
c
      if (lpt.ge.0) then
         write (lpt,1005) spg(1:leng(spg))
         if (ncent.eq.0) write (lpt,1006)
         if (ncent.eq.1) write (lpt,1007)
         write (lpt,1008) ltyp(lcent)
         write (lpt,1009) syst(lsys)
         write (lpt,1010) chlaue(laue)
         write (lpt,1011) multgen
         if (naxi.gt.0) write (lpt,1012) nax(naxi)
         if (naxi.eq.0) write (lpt,1013)
         if (npol.gt.0) write (lpt,1014) polar(npol)
         if (npol.le.0) write (lpt,1015)
         write (lpt,1016) neqv
      endif
c
c.....first part concluded, start with symmetry relations
c
      do 200 i=1,neqv
         do 190 j=1,3
            ij = 2*jrt(j,1,i)+3*jrt(j,2,i)+4*jrt(j,3,i)+5
            ik = jrt(j,4,i)+1
            if (ik.gt.1 .and. ij.gt.6) ij=ij+3
            outl(j,2,i) = xyz(ij)
            outl(j,1,i) = tra(ik)
 190     continue
 200  continue
c
c.....write the symmetry matrices and lattice centering vectors.
c
      if (lpt .ge. 0) then
         write (lpt,1026) ((outl(i1,1,i),outl(i1,2,i),i1=1,3),i=1,neqv)
         write (lpt, 7001) neqv
         write (lpt, 7020) ncv
         do 7030 i=1,ncv
            write (lpt, 7025) (cen(j,i), j=1,3)
 7030    continue
      endif
c
c.....Formats.
c
 1026 format (3(2x,'(',2(2a3,1h,),2a3,') '))
 1005 format (1x,'the space group is ',a30)
 1006 format (1x,'the structure is noncentrosymmetric')
 1007 format (1x,'the structure is centrosymmetric')
 1008 format (1x,'the lattice is ',a12)
 1009 format (1x,'the system is ',a12)
 1010 format (1x,'the laue group is ',a8)
 1011 format (1x,'the multiplicity of the general position is ',i3)
 1012 format (1x,'the unique axis is ',a1)
 1013 format (1x,'there is no unique axis')
 1014 format (1x,'the space group is polar along ',a3/)
 1015 format (1x,'the space group is not polar'/)
 1016 format (1x,'the number of generated symmetry relations is ',i2)
 7001 format (//1x,'the number of Symmetry Matrices is',i5)
 7020 format (1x,'the number of Lattice Centering Vectors is ',i5)
 7025 format (1x,'cenvec : ', 3f10.7)
c
      return
      end
