c
c.....spgcom.inc - symmetry information about the primitive cell.
c
c     lsys ....... crystallographic system: 1=triclinic, 2=monoclinic,
c                  3=orthorrombic, 4=tetragonal, 5=trigonal-R,
c                  6=trigonal-H, 7=hexagonal, 8=cubic.
c     laue ....... laue group number:
c                  1=1bar, 2=2/m, 3=mmm, 4=4/m, 5=4/mm, 6=r3r, 7=r3mr,
c                  8=3, 9=3m1, 10=31m, 11=6/m, 12=6/mmm, 13=m3, 14=m3m.
c     naxis ...... unique axis for monoclinic groups (1=x, ..3=z).
c     ncent ...... 1bar flag (0/1) for cs/non-cs (cs=centrosymmetric).
c     lcent ...... type of lattice centering:
c                  1=P, 2=A, 3=B, 4=C, 5=I, 6=F, 7=R.
c     npol ....... orientation of the space group polarity:
c                  1=x, 2=y, 3=xy, 4=z, 5=xz, 6=yz, 7=xyz, 8=111.
c     multgen .... multiplicity of the general position
c     neqv ....... number of symmetry matrices generated.
c     ncv ........ number of centering vectors.
c     jrt ........ integer (3,4,24) codified rotation matrices.
c     cen ........ real*8 (3,4) matrix, lattice centering vectors.
c     rotm ....... real*8 (3,4,24) matrix, decodified version of jrt.
c
      integer           laue, naxis, ncent, lcent, neqv, npol, jrt, ncv
      integer           lsys, multgen
      real*8            cen, rotm
      common /spacei/   laue, naxis, ncent, lcent, neqv, npol, lsys,
     &                  jrt(3,4,24), ncv, multgen
      common /spacer/   cen(3,4), rotm(3,4,24)
