c
c-----------------------------------------------------------------------
c
      subroutine triprod (n,amat,bmat,cmat)
c
c.....triprod - computes the product of matrices: Amat*Bmat*Cmat.
c
c     Each of the matrices is symmetric and is stored in a supervector
c     (the upper triangle). The same is valid for the result matrix.
c
c.....Input parameters:
c     N .... dimension of the square symmetric matrices.
c     Amat . first matrix.
c     Bmat . second matrix.
c     Cmat . third matrix.
c
c.....Output parameter:
c     Bmat . the resultant matrix.
c
      include           'implicit.inc'
      include           'global.inc'
      real*8            amat((mpgao*(mpgao+1))/2),
     &                  bmat((mpgao*(mpgao+1))/2),
     &                  cmat((mpgao*(mpgao+1))/2),
     &                  res((mpgao*(mpgao+1))/2)
c
c.....Formula that returns the supervector elements associated with a
c     given element of the original square matrix:
      idx(i1,i2)=(max0(i1,i2)*(max0(i1,i2)-1))/2+min0(i1,i2)
c
c.....Compute the triple product and store it in RES():
      ij=0
      do 10 i=1,n
         do 15 j=1,i
            ij=ij+1
            prod=0d0
            do 20 k=1,n
               do 25 l=1,n
                  prod=prod+amat(idx(i,k))*bmat(idx(k,l))*
     &                      cmat(idx(l,j))
 25            continue
 20         continue
            res(ij)=prod
 15      continue
 10   continue
c
c.....Redefine BMAT()=RES():
      ij=0
      do 30 i=1,n
         do 35 j=1,i
            ij=ij+1
            bmat(ij)=res(ij)
 35      continue
 30   continue
      return
      end
