c
c-----------------------------------------------------------------------
c
      subroutine writecoef (fichero, ni)
c
c.....writecoef - write ionic description files.
c
c     Writes out in Fichero the data corresponding to the NI-th type of
c     ion. The structure of Fichero will be such that it can be read in
c     by ReadCoef.
c
c.....Input parameters:
c     Fichero ... Name of the file to be written.
c     NI ........ Identification number of the ion.
c
      include           'implicit.inc'
      include           'global.inc'
      include           'cont.inc'
      include           'symmetry.inc'
      include           'coup.inc'
c
      integer           ni
      character*(*)     fichero
      character*(9)     lab
      character*(128)   cdum
c
      integer           lualloc
c
c.....open the file:
c
      if (ni .gt. mnt) call error ('writecoef', 'ni > mnt', faterr)
      lui = lualloc (lui)
      open (lui, file = fichero, status = 'unknown', iostat = nios)
      if (nios .ne. 0) then
         cdum = 'can''t open ionic file'//fichero
         call error ('writecoef', cdum, faterr)
      endif
c
c.....write the data:
c
      lab='LOCAL'
      write (lui,100) lab
      ll = leng (tition(ni))
      write (lui,100) tition(ni)(1:ll)
      write (lui,200) (ngaos(i,ni),i=1,nirrep(ni))
      write (lui,210) (ngelec(k,ni),k=1,ntgaos(ni))
      write (lui,220) (georb(k,ni),k=1,ntgaos(ni))
      do i=1,nirrep(ni)
         do j=1,ngaos(i,ni)
            j1=j+nagaos(i,ni)
            nbas1=npgao(i,ni)
            write (lui,230) (gc(k,j1,ni),k=1,nbas1)
         enddo
      enddo
      if (openshell(ni)) then
         write (lui,300) numjcoup(ni), numkcoup(ni)
         do j = 1, numjcoup(ni)
            do lpq=1,ndens(ni)
               do lrs=1,lpq
                  write (lui,310) njcoup(lpq,lrs,j,ni),
     &                            xjcoup(lpq,lrs,j,ni),1d0
               enddo
            enddo 
         enddo
         do j = 1, numkcoup(ni)
            do lpq=1,ndens(ni)
               do lrs=1,lpq
                  write (lui,320) nkcoup(lpq,lrs,j,ni),
     & xkcoup(lpq,lrs,j,1,ni),1d0,xkcoup(lpq,lrs,j,2,ni),1d0
               enddo
            enddo
         enddo
      endif
      write (lui,400) eeff(ni), eadd(ni), ecorr(ni), ekin(ni), epot(ni)
c
c.....Close the file:
      close (lui)
      call lunalloc (lui)
c
 100  format (a)
 200  format (8i5)
 210  format (6f13.6)
 220  format (4f20.10)
 230  format (5e20.12)
 300  format (2i3)
 310  format (i3, 1pe17.9, 0pf6.2)
 320  format (i3, 1pe17.9, 0pf6.2, 1pe17.9, 0pf6.2) 
 400  format (1p5e17.9)
      end
