c
c-----------------------------------------------------------------------
c
      subroutine ynver (n,ss)
c
c.....ynver - computes the inverse of a matrix using the Gauss-Jordan
c     method, adapted for a symmetric matrix.
c
c.....Input parameters:
c     N .... dimension of the matrix.
c     SS ... supervector containing the matrix to be inverted (the
c            upper triangle).
c
c.....Output parameters:
c     SS ... supervector containing the inverse matrix.
c
      include           'implicit.inc'
      include           'global.inc'
      dimension ss((mpgao*(mpgao+1))/2),a(mpgao,mpgao+mpgao)
c
      m=2*n
c
c.....Store SS() in the first half of A():
      ij=0
      do 10 i=1,n
         do 15 j=1,i
            ij=ij+1
            a(i,j)=ss(ij)
            a(j,i)=a(i,j)
 15      continue
 10   continue
c
c.....The second half of A() will contain the identity matrix:
      do 20 i=1,n
         do 25 j=n+i,m
            a(i,j)=1.d0
            if((j-n).ne.i) a(i,j)=0.d0
            a(j-n,i+n)=a(i,j)
 25      continue
 20   continue
c
c.....Gauss-Jordan elimination:
      do 30 i=1,n
         pivote=a(i,i)
         do 35 j=i,m
            a(i,j)=a(i,j)/pivote
 35      continue
         do 40 k=1,n
            if (k.ne.i) then
               cero=a(k,i)
               do 45 j=i,m
                  a(k,j)=a(k,j)-cero*a(i,j)
 45            continue
            endif
 40      continue
 30   continue
c
c.....Store the lower triangle of the inverse matrix in SS():
      ij=0
      do 50 i=1,n
         do 55 j=n+1,n+i
            ij=ij+1
            ss(ij)=a(i,j)
 55      continue
 50   continue
      return
      end
